<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Setforms2\Shared\ORM\DateTime;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services\CancelamentoZeramentoSaldoService;
use Teknisa\MAN\Services\EvoluiSaldo;
use Teknisa\MAN\Services\NovoCodigo;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;

class CancelamentoZeramentoSaldo extends CrudWithParameterBag  {

    const DATASOURCE = 'vnd09505_cancelamentoZeramento';
    
    protected $dataSourceName;
    protected $parameterBagColumns = array('NRORG', 'CDCLIENTE', 'CDTIPOCONS');
    
    protected $CancelamentoZeramentoSaldoService;
    protected $EvoluiSaldo;
    protected $novoCodigo;

    public function __construct(Manager $dataSourceManager, ParameterBag $parameterBag, CancelamentoZeramentoSaldoService $CancelamentoZeramentoSaldoService, EvoluiSaldo $EvoluiSaldo, NovoCodigo $novoCodigo) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->CancelamentoZeramentoSaldoService = $CancelamentoZeramentoSaldoService;
        $this->EvoluiSaldo = $EvoluiSaldo;        
        $this->novoCodigo = $novoCodigo;
    }
    
    //public function find(DTO\Request\Filter $request, DTO\Response $response) {
    //    $this->dataSourceName = $this::;
    //    parent::find($request, $response);
    //} 
    
    public function CancelaZeramento(DTO\Request\DataSet $request, DTO\Response $response){
        $conditions = $request->getDataSet()->getRows()[0];
        $this->dataSourceName = $this::DATASOURCE;
        $conditions['DSOPEEXTCONS'] = 'Zeramento do Saldo';
        $conditions['IDTPMOVEXT'] = 'C';
        $saldosNegativos = $this->CancelamentoZeramentoSaldoService->GetSaldoNegativos($conditions);
        if (!empty($saldosNegativos)) {
            foreach ($saldosNegativos as &$saldoNegativo) {
                $NRSEQMOVEXT = $this->CancelamentoZeramentoSaldoService->GetNextNrseqmovext($saldoNegativo)[0]['NRSEQMOVEXT'];
                $saldoNegativo['NRSEQMOVEXT'] = $NRSEQMOVEXT;
                $saldoNegativo['DSOPEEXTCONS'] = 'Cancela Zeramento';
                $saldoNegativo['CDFILIAL'] = $conditions['CDFILIAL'];
                $saldoNegativo['IDTPMOVEXT'] = 'D';
                $saldoNegativo['IDIMPEXTCONS'] = 'N';
                $saldoNegativo['IDCANZERASALD'] = 'N';
                $saldoNegativo['VRSALDCONEXT'] = $saldoNegativo['VRMOVEXTCONS'] * -1;
                $saldoNegativo['DTMOVEXTCONS'] = date("d/m/Y H:i:s", strtotime(str_replace('/', '-', $saldoNegativo['DTMOVEXTCONS'])) +1);
                //$saldoNegativo['IDIMPEXTRATO'] = 'S'; (Fixo 'S' na query)
                //$saldoNegativo['DTULTATUEXT'] = SYSDATE;
                $saldoNegativo['NRSEQREGCREDVND'] = $this->novoCodigo->getCodeByTableName('EXTRATOCONSVND', $conditions['NRORG']);
                $saldoNegativo['NRSEQREGCREDVND'] = str_pad($saldoNegativo['NRSEQREGCREDVND'], 20, '0', STR_PAD_LEFT);
                $this->CancelamentoZeramentoSaldoService->insertCancelaZeramento($saldoNegativo);
                $this->CancelamentoZeramentoSaldoService->atualizaExtratoCons($saldoNegativo);
                $this->EvoluiSaldo->EvoluiSaldoFunction($saldoNegativo);
            }
            $response->addMessage(new Message('Cancelamento de zeramento de saldo efetuado com Sucesso!'));
        }
        else{
            $response->addMessage(new Message('Não houve nenhum zeramento efetuado.'));
        }
    }
}