<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use \Zeedhi\Framework\Util\Functions;
use Teknisa\MAN\Utilities;

class RelSinteseFaturamento {
    protected $entityManager;
    protected $util;

	public function __construct(EntityManager $entityManager, Utilities\Util $util) {
        $this->entityManager = $entityManager;
        $this->util = $util;
    }
    
    public function getParams($conditions){
        
        $params = array(
         	":CDFILIAL"    => $conditions['CDFILIAL'],
         	":CDLOJA"      => $conditions['CDLOJA'],
         	":TCDLOJA"     => $conditions['TCDLOJA'],
         	":DATAINI"     => $conditions['DATAINI'],
         	":DATAFIN"     => $conditions['DATAFIN'],
         	":MODALIDADE"  => $conditions['MODALIDADE'],
         	":TMODALIDADE" => $conditions['TMODALIDADE'],
         	":NRORG"       => $conditions['NRORG'],
         	":FLAGBALTAA"  => $conditions['FLAGBALTAA'],
         	":IDGRPNVL"    => isset($conditions['IDGRPNVL'])    ? $conditions['IDGRPNVL']    : 'N',
            ":IDSITUVENDA" => isset($conditions['IDSITUVENDA']) ? $conditions['IDSITUVENDA'] : 'O',
            ":IDVENDACAN"  => isset($conditions['IDVENDACAN'])  ? $conditions['IDVENDACAN']  : 'C',
            ":IDTPAMBNFCE" => isset($conditions['IDTPAMBNFCE']) ? $conditions['IDTPAMBNFCE'] : '1'
 		);
 		
 		return $params;
    }
    
    public function findRel($conditions) {
        $conditions['IDGRPNVL'] = (isset($conditions['IDGRPNVL'])) ? $conditions['IDGRPNVL'] : null; 
 		$params = $this->getParams($conditions);
        $conditions['CDNVPRODUTO'] = (isset($conditions['CDNVPRODUTO'])) ? $conditions['CDNVPRODUTO'] : '1';
        
        $query = $this->getSQL($conditions['TIPORELATORIO'], $conditions['RELATORIO'], $conditions['IDGRPNVL'], $conditions['CDNVPRODUTO']);
        
        return $this->entityManager->getConnection()->fetchAll($query, $params);
    }
     
    public function findRelTotPorMod($conditions) {
        //Realiza a buscas CD da MODALIDADE conforme filtro de modalidade
        if($conditions['TMODALIDADE'] !== 'T'){
            $cdMod = explode('_', $conditions['MODALIDADE']);
            $conditions['MODALIDADE'] = "";
            $strMod = "";
            
            foreach($cdMod as $mod){
                if($mod == "BAL"){
                        $paramsMod = array(
                         	":MODALIDADE"  => "BAL",
                         	":TMODALIDADE" => $conditions['TMODALIDADE'],
                         	":NRORG"       => $conditions['NRORG'],
                         	":FLAG"  => "AUT_TAA",
                         	":TFLAG"  => "",
                         	":P11"  => "1",
                         	":P12"  => "3",
                         	":P21"  => "5",
                         	":P22"  => "3"
                 		);
                 		$arrayCdMod = $this->entityManager->getConnection()->fetchAll(self::GET_ARRAY_MODALIDADE, $paramsMod);
                 		foreach($arrayCdMod as $key => $value){
                 		    $strMod .= $value['IDORIGEMVENDA'].'_';
                 		}
                 		
                }else if($mod == "CMD"){
                        $paramsMod = array(
                         	":MODALIDADE"  => "CMD",
                         	":TMODALIDADE" => $conditions['TMODALIDADE'],
                         	":NRORG"       => $conditions['NRORG'],
                         	":FLAG"  => "AUT_TAA",
                         	":TFLAG"  => "",
                         	":P11"  => "1",
                         	":P12"  => "3",
                         	":P21"  => "5",
                         	":P22"  => "3"
                 		);
                 		$arrayCdMod = $this->entityManager->getConnection()->fetchAll(self::GET_ARRAY_MODALIDADE, $paramsMod);
                 		foreach($arrayCdMod as $key => $value){
                 		    $strMod .= $value['IDORIGEMVENDA'].'_';
                 		}
                 		
                }else if($mod == "DLV"){
                        $paramsMod = array(
                         	":MODALIDADE"  => "DLV",
                         	":TMODALIDADE" => $conditions['TMODALIDADE'],
                         	":NRORG"       => $conditions['NRORG'],
                         	":FLAG"  => "AUT_TAA",
                         	":TFLAG"  => "",
                         	":P11"  => "1",
                         	":P12"  => "3",
                         	":P21"  => "5",
                         	":P22"  => "3"
                 		);
                 		$arrayCdMod = $this->entityManager->getConnection()->fetchAll(self::GET_ARRAY_MODALIDADE, $paramsMod);
                 		foreach($arrayCdMod as $key => $value){
                 		    $strMod .= $value['IDORIGEMVENDA'].'_';
                 		}
                }else if($mod == "MES"){
                        $paramsMod = array(
                         	":MODALIDADE"  => "MES",
                         	":TMODALIDADE" => $conditions['TMODALIDADE'],
                         	":NRORG"       => $conditions['NRORG'],
                         	":FLAG"  => "AUT_TAA_APP",
                         	":TFLAG"  => "",
                         	":P11"  => "1",
                         	":P12"  => "3",
                         	":P21"  => "5",
                         	":P22"  => "3"
                 		);
                 		$arrayCdMod = $this->entityManager->getConnection()->fetchAll(self::GET_ARRAY_MODALIDADE, $paramsMod);
                 		foreach($arrayCdMod as $key => $value){
                 		    $strMod .= $value['IDORIGEMVENDA'].'_';
                 		}
                }else if($mod == "TAA"){
                        $paramsMod = array(
                         	":MODALIDADE"  => "AUT_TAA",
                         	":TMODALIDADE" => $conditions['TMODALIDADE'],
                         	":NRORG"       => $conditions['NRORG'],
                         	":FLAG"  => "",
                         	":TFLAG"  => "T",
                         	":P11"  => "5",
                         	":P12"  => "3",
                         	":P21"  => "1",
                         	":P22"  => "3"
                 		);
                 		$arrayCdMod = $this->entityManager->getConnection()->fetchAll(self::GET_ARRAY_MODALIDADE, $paramsMod);
                 		foreach($arrayCdMod as $key => $value){
                 		    $strMod .= $value['IDORIGEMVENDA'].'_';
                 		}
                }else if($mod == "THR"){
                        $paramsMod = array(
                         	":MODALIDADE"  => "THR",
                         	":TMODALIDADE" => $conditions['TMODALIDADE'],
                         	":NRORG"       => $conditions['NRORG'],
                         	":FLAG"  => "AUT_TAA",
                         	":TFLAG"  => "",
                         	":P11"  => "1",
                         	":P12"  => "3",
                         	":P21"  => "5",
                         	":P22"  => "3"
                 		);
                 		$arrayCdMod = $this->entityManager->getConnection()->fetchAll(self::GET_ARRAY_MODALIDADE, $paramsMod);
                 		foreach($arrayCdMod as $key => $value){
                 		    $strMod .= $value['IDORIGEMVENDA'].'_';
                 		}
                }else if($mod == "INDEFIN"){
                        $paramsMod = array(
                         	":MODALIDADE"  => "INDEFIN",
                         	":TMODALIDADE" => $conditions['TMODALIDADE'],
                         	":NRORG"       => $conditions['NRORG'],
                         	":FLAG"  => "AUT_TAA",
                         	":TFLAG"  => "",
                         	":P11"  => "1",
                         	":P12"  => "3",
                         	":P21"  => "5",
                         	":P22"  => "3"
                 		);
                 		$arrayCdMod = $this->entityManager->getConnection()->fetchAll(self::GET_ARRAY_MODALIDADE, $paramsMod);
                 		foreach($arrayCdMod as $key => $value){
                 		    $strMod .= $value['IDORIGEMVENDA'].'_';
                 		}
                }
            }
            $conditions['MODALIDADE'] = $strMod;
            unset($strMod);
        }
        
        $params = $this->getParams($conditions);
        $result = $this->entityManager->getConnection()->fetchAll(self::GET_FATURAMENTO_TOTAL_POR_MODALIDADE, $params);
        
        $array = [];
        
        foreach ($result as $value) {
            $array[$value['CDFILIAL']]['NMFILIAL'] = $value['NMFILIAL'];
            $array[$value['CDFILIAL']]['CDFILIAL'] = $value['CDFILIAL'];
            $array[$value['CDFILIAL']]['CODFILIAL'] = $value['CODFILIAL'];
            
            if(mb_strpos(strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])), 'AUTOATENDIMENTO') !== false){
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE']))] = $value['NMMODALIDADE'];
                $array[$value['CDFILIAL']]['TAA_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];
            }else if(mb_strpos(strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])), 'BALCAO') !== false){
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE']))] = $value['NMMODALIDADE'];
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])).'_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];
            }else if(mb_strpos(strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])), 'COMANDA') !== false){
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE']))] = $value['NMMODALIDADE'];
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])).'_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];    
            }else if(mb_strpos(strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])), 'DELIVERY') !== false){
                $array[$value['CDFILIAL']]['DELIVERY'] = 'Delivery';
                array_key_exists('DELIVERY_VALOR_VENDIDO', $array[$value['CDFILIAL']]) ?
                    $array[$value['CDFILIAL']]['DELIVERY_VALOR_VENDIDO']+= $value['VALOR_VENDIDO'] : 
                    $array[$value['CDFILIAL']]['DELIVERY_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];
            }else if(mb_strpos(strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])), 'DRIVE') !== false){
                $array[$value['CDFILIAL']]['DRIVE_THRU'] = 'Drive Thru';
                array_key_exists('DRIVE_THRU_VALOR_VENDIDO', $array[$value['CDFILIAL']]) ?
                    $array[$value['CDFILIAL']]['DRIVE_THRU_VALOR_VENDIDO']+= $value['VALOR_VENDIDO'] : 
                    $array[$value['CDFILIAL']]['DRIVE_THRU_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];
            }else if(mb_strpos(strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])), 'MESA') !== false){
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE']))] = $value['NMMODALIDADE'];
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])).'_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];
            }else if(mb_strpos(strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])), 'THRU') !== false){
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE']))] = $value['NMMODALIDADE'];
                $array[$value['CDFILIAL']][strtoupper($this->util->sanitizeString($value['NMMODALIDADE'])).'_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];
            }else {
                $array[$value['CDFILIAL']]['OUTROS'] = 'Outros';
                array_key_exists('OUTROS_VALOR_VENDIDO', $array[$value['CDFILIAL']]) ?
                    $array[$value['CDFILIAL']]['OUTROS_VALOR_VENDIDO']+= $value['VALOR_VENDIDO'] : 
                    $array[$value['CDFILIAL']]['OUTROS_VALOR_VENDIDO'] = $value['VALOR_VENDIDO'];
            }
             
            if(Functions::arrayKeyExists ('VRDESCONTO', $array[$value['CDFILIAL']])) {
               $array[$value['CDFILIAL']]['VRDESCONTO'] = $array[$value['CDFILIAL']]['VRDESCONTO'] + $value['VRDESCONTO'];
            } else {
                $array[$value['CDFILIAL']]['VRDESCONTO'] = $value['VRDESCONTO'];
            }
        }
        $indexArray = [];
        foreach ($array as $value) {
            
            Functions::arrayKeyExists('BALCAO_VALOR_VENDIDO', $value)  ? $value['BALCAO_VALOR_VENDIDO'] : $value['BALCAO_VALOR_VENDIDO'] = 0;
            Functions::arrayKeyExists('COMANDA_VALOR_VENDIDO', $value) ? $value['COMANDA_VALOR_VENDIDO']: $value['COMANDA_VALOR_VENDIDO'] = 0;
            Functions::arrayKeyExists('DELIVERY_VALOR_VENDIDO', $value) ? $value['DELIVERY_VALOR_VENDIDO'] : $value['DELIVERY_VALOR_VENDIDO'] = 0;
            Functions::arrayKeyExists('MESA_VALOR_VENDIDO', $value) ? $value['MESA_VALOR_VENDIDO'] : $value['MESA_VALOR_VENDIDO'] = 0;
            Functions::arrayKeyExists('TAA_VALOR_VENDIDO', $value) ? $value['TAA_VALOR_VENDIDO'] : $value['TAA_VALOR_VENDIDO'] = 0;
            Functions::arrayKeyExists('DRIVE_THRU', $value) ? $value['DRIVE_THRU'] : $value['DRIVE_THRU'] = 'Drive Thru'; 
            Functions::arrayKeyExists('DRIVE_THRU_VALOR_VENDIDO', $value) ? $value['DRIVE_THRU_VALOR_VENDIDO'] : $value['DRIVE_THRU_VALOR_VENDIDO'] = 0; 
            Functions::arrayKeyExists('OUTROS', $value) ? $value['OUTROS'] : $value['OUTROS'] = 'Outros';
            Functions::arrayKeyExists('OUTROS_VALOR_VENDIDO', $value) ? $value['OUTROS_VALOR_VENDIDO'] : $value['OUTROS_VALOR_VENDIDO'] = 0;
            $value['TOTAL'] = $value['BALCAO_VALOR_VENDIDO'] + $value['COMANDA_VALOR_VENDIDO'] + 
                              $value['DELIVERY_VALOR_VENDIDO'] + $value['MESA_VALOR_VENDIDO']  +
                              $value['TAA_VALOR_VENDIDO'] + $value['DRIVE_THRU_VALOR_VENDIDO'] + 
                              $value['OUTROS_VALOR_VENDIDO'];
            array_push($indexArray, $value);
        }
        
        return $indexArray;
    }
    
    public function findFaturamentoDeliveryAnaliticoGeral($params){
 		return $this->entityManager->getConnection()->fetchAll(self::GET_FATURAMENTODELIVERY_GERAL_ANALITICO, $params);
    }
    
    public function findFaturamentoDeliverySinteticoGeral($params){
 		return $this->entityManager->getConnection()->fetchAll(self::GET_FATURAMENTODELIVERY_GERAL_SINTETICO , $params);
    }
    
    public function findFaturamentoDeliveryAnaliticoDia($params){
        return $this->entityManager->getConnection()->fetchAll(self::GET_FATURAMENTODELIVERY_DIA_ANALITICO, $params);
    }
    
    public function findFaturamentoDeliverySinteticoDia($params){
        return $this->entityManager->getConnection()->fetchAll(self::GET_FATURAMENTODELIVERY_DIA_SINTETICO, $params);
    }
    
    public function buildParamsFaturamento($conditions){
        
        $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        
        if(!Functions::arrayKeyExists('CDLOJA', $conditions)) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        
        if(!Functions::arrayKeyExists('MODALIDADE', $conditions)) {
            $conditions['MODALIDADE'] = null;
            $conditions['TMODALIDADE'] = 'T';
        } else {
            $conditions['MODALIDADE'] = implode('_', $conditions['MODALIDADE']);
            $conditions['TMODALIDADE'] = null;
        }
        
        $conditions['FLAGBALTAA'] = 'N';
        $conditions['FLAGBALTAA'] = (strpos($conditions['MODALIDADE'], 'BAL') !== false ? (strpos($conditions['MODALIDADE'], 'TAA') !== false ? 'N' : 'S') : 'N');
        
        if(Functions::arrayKeyExists('DTENTRVENDA', $conditions)) {
            $conditions['DATAINI'] = $conditions['DTENTRVENDA'][0];
            $conditions['DATAFIN'] = $conditions['DTENTRVENDA'][1];
            unset($conditions['DTENTRVENDA']);
        }
        
        if(Functions::arrayKeyExists('IDTPAMBNFCE', $conditions)) {
            $conditions['IDTPAMBNFCE'] = $conditions['IDTPAMBNFCE'];
        } else {
            $conditions['IDTPAMBNFCE'] = '1';
        }
        
        return $conditions;
    }
    
    public function reorderResultsbyDate($result){
        
        $currentFilial = $result[0]['CODIGOFILIAL']; 
        $data = $result[0]['DATA']; 
        
        $i = 0;
        
        foreach($result as $index => $res) {
            
            if($res['CODIGOFILIAL'] === $currentFilial) {
                if($data === $res['DATA']) {
                    $result[$index]['DATA'] = str_pad(($i + 1), 3, "0", STR_PAD_LEFT) . ' - ' . $result[$index]['DATA']; 
                } else {
                    $data = $result[$index]['DATA'];
                    $i++;
                    $result[$index]['DATA'] = str_pad(($i + 1), 3, "0", STR_PAD_LEFT) . ' - ' . $result[$index]['DATA']; 
                }
            } else {
                $currentFilial = $res['CODIGOFILIAL'];
                $i = -1;
                
                if($data === $res['DATA']) {
                    $result[$index]['DATA'] = str_pad(($i + 1), 3, "0", STR_PAD_LEFT) . ' - ' . $result[$index]['DATA']; 
                } else {
                    $data = $result[$index]['DATA'];
                    $i++;
                    $result[$index]['DATA'] = str_pad(($i + 1), 3, "0", STR_PAD_LEFT) . ' - ' . $result[$index]['DATA']; 
                }
            }
        }
        
        return $result;
    }
    
    public function getSQL($modalidade = 'A', $tipoRelatorio = 'GERAL', $idgrpnvl = 'N', $cdnvproduto){
        if($modalidade == 'A' && $tipoRelatorio == 'GERAL'){
            if($idgrpnvl == 'N'){
                $NUMITENS = "1 AS NUMITENS,";
                $ONTAB2 = null;
                $ONTAB3 = null;
                $GROUP = "TAB1.CDFILIAL,
                    	   TAB1.NMFILIAL,
                    	   TAB1.MODALIDADE";
                $GROUP_BY = "TAB1.CDFILIAL,
                    		 TAB1.NMFILIAL,
                    		 TAB1.MODALIDADE";
                $ORDER_BY = "TAB1.CDFILIAL,
                             TAB1.NMFILIAL,	
                             TAB1.MODALIDADE";
            }
            if($idgrpnvl == 'S'){
                $NUMITENS = "COUNT(*) OVER (PARTITION BY V.NRSEQVENDA) AS NUMITENS,";
                $ONTAB2 = "AND TAB1.CDNVPRODUTO1 = TAB2.CDNVPRODUTO1
                AND TAB1.NMNVPRODUTO1 = TAB2.NMNVPRODUTO1
                AND TAB1.CDNVPRODUTO2 = TAB2.CDNVPRODUTO2
                AND TAB1.NMNVPRODUTO2 = TAB2.NMNVPRODUTO2
                AND TAB1.CDNVPRODUTO3 = TAB2.CDNVPRODUTO3
                AND TAB1.NMNVPRODUTO3 = TAB2.NMNVPRODUTO3
                AND TAB1.CDNVPRODUTO4 = TAB2.CDNVPRODUTO4
                AND TAB1.NMNVPRODUTO4 = TAB2.NMNVPRODUTO4
                AND TAB1.CDNVPRODUTO5 = TAB2.CDNVPRODUTO5
                AND TAB1.NMNVPRODUTO5 = TAB2.NMNVPRODUTO5";
                $ONTAB3 = "AND TAB1.CDNVPRODUTO1 = TAB3.CDNVPRODUTO1
                AND TAB1.NMNVPRODUTO1 = TAB3.NMNVPRODUTO1
                AND TAB1.CDNVPRODUTO2 = TAB3.CDNVPRODUTO2
                AND TAB1.NMNVPRODUTO2 = TAB3.NMNVPRODUTO2
                AND TAB1.CDNVPRODUTO3 = TAB3.CDNVPRODUTO3
                AND TAB1.NMNVPRODUTO3 = TAB3.NMNVPRODUTO3
                AND TAB1.CDNVPRODUTO4 = TAB3.CDNVPRODUTO4
                AND TAB1.NMNVPRODUTO4 = TAB3.NMNVPRODUTO4
                AND TAB1.CDNVPRODUTO5 = TAB3.CDNVPRODUTO5
                AND TAB1.NMNVPRODUTO5 = TAB3.NMNVPRODUTO5";
                if($cdnvproduto == '1'){
                    $GROUP = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO1 AS NVPRODUTO , TAB1.NMNVPRODUTO1 AS NMNVPRODUTO,	
                        		 TAB1.MODALIDADE";
                    $GROUP_BY = "TAB1.CDFILIAL,
                    	   TAB1.NMFILIAL,
                    	   TAB1.CDNVPRODUTO1, TAB1.NMNVPRODUTO1,
                    	   TAB1.MODALIDADE";
                    $ORDER_BY = "TAB1.CDFILIAL,
                                 TAB1.NMFILIAL,	
                                 TAB1.CDNVPRODUTO1, TAB1.NMNVPRODUTO1,
                                 TAB1.MODALIDADE";
                }
                if($cdnvproduto == '2'){
                    $GROUP = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO2 AS NVPRODUTO, TAB1.NMNVPRODUTO2 AS NMNVPRODUTO,	
                        		 TAB1.MODALIDADE";
                    $GROUP_BY = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO2, TAB1.NMNVPRODUTO2,	
                        		 TAB1.MODALIDADE";
                    $ORDER_BY = "TAB1.CDFILIAL,
                                 TAB1.NMFILIAL,	
                                 TAB1.CDNVPRODUTO2, TAB1.NMNVPRODUTO2,
                                 TAB1.MODALIDADE";
                }
                if($cdnvproduto == '3'){
                    $GROUP = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO3 AS NVPRODUTO, TAB1.NMNVPRODUTO3 AS NMNVPRODUTO,	
                        		 TAB1.MODALIDADE";
                    $GROUP_BY = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO3, TAB1.NMNVPRODUTO3,	
                        		 TAB1.MODALIDADE";
                    $ORDER_BY = "TAB1.CDFILIAL,
                                 TAB1.NMFILIAL,	
                                 TAB1.CDNVPRODUTO3, TAB1.NMNVPRODUTO3,
                                 TAB1.MODALIDADE";
                }
                if($cdnvproduto == '4'){
                    $GROUP = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO4 AS NVPRODUTO, TAB1.NMNVPRODUTO4 AS NMNVPRODUTO,	
                        		 TAB1.MODALIDADE";
                    $GROUP_BY = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO4, TAB1.NMNVPRODUTO4,	
                        		 TAB1.MODALIDADE";
                    $ORDER_BY = "TAB1.CDFILIAL,
                                 TAB1.NMFILIAL,	
                                 TAB1.CDNVPRODUTO4, TAB1.NMNVPRODUTO4,
                                 TAB1.MODALIDADE";
                }
                if($cdnvproduto == '5'){
                    $GROUP = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO5 AS NVPRODUTO, TAB1.NMNVPRODUTO5 AS NMNVPRODUTO,	
                        		 TAB1.MODALIDADE";
                    $GROUP_BY = "TAB1.CDFILIAL,
                        		 TAB1.NMFILIAL,	
                        		 TAB1.CDNVPRODUTO5, TAB1.NMNVPRODUTO5,	
                        		 TAB1.MODALIDADE";
                    $ORDER_BY = "TAB1.CDFILIAL,
                                 TAB1.NMFILIAL,	
                                 TAB1.CDNVPRODUTO5, TAB1.NMNVPRODUTO5,
                                 TAB1.MODALIDADE";
                }
            }
            
        }else if($modalidade == 'S' && $tipoRelatorio == 'GERAL'){
            $ONTAB2 = null;
            $ONTAB3 = null;
            $GROUP = self::GROUP_MOD_TODOS;
            $GROUP_BY = "TAB1.CDFILIAL,
            		 TAB1.NMFILIAL";
            $ORDER_BY = "TAB1.CDFILIAL,
            		 TAB1.NMFILIAL";
        }else if($tipoRelatorio == 'DIA'){
            $ONTAB2 = null;
            $ONTAB3 = null;
            if($modalidade == 'A' || $modalidade == 'D'){
                $GROUP = self::GROUP_MOD_DIA_ANA;    
                $GROUP_BY = "TAB1.CDFILIAL,
            		 TAB1.NMFILIAL,		 
            		 TAB1.DTENTRVENDA,
            		 TAB1.MODALIDADE";
            		 
                $ORDER_BY = "TAB1.CDFILIAL,
                		 TAB1.NMFILIAL,		 
                		 TAB1.DTENTRVENDA,
                		 TAB1.MODALIDADE
                		 ";
            }else if($modalidade == 'S'){
                $ONTAB2 = null;
                $ONTAB3 = null;
                $GROUP_BY = "TAB1.CDFILIAL,
            		 TAB1.NMFILIAL,		 
            		 TAB1.DTENTRVENDA";
            		 
                $ORDER_BY = "TAB1.CDFILIAL,
                		 TAB1.NMFILIAL,		 
                		 TAB1.DTENTRVENDA
                		 ";
                $GROUP = self::GROUP_MOD_DIA_SIN;
            }
        }
        
        $query = "
        SELECT FINALTAB.CDFILIAL || ' - ' || FINALTAB.NMFILIAL AS CODFILIAL, FINALTAB.CDFILIAL||' - '||'Periodo:' || :DATAINI || ' a ' || :DATAFIN AS PERIODO,  FINALTAB.CDFILIAL AS CODIGOFILIAL, 
           FINALTAB.*, 
        
            CASE 
                WHEN FINALTAB.NROPESSOAS > 0 THEN ROUND((FINALTAB.VALOR_FATURAMENTO + FINALTAB.VRACRESCIMO - FINALTAB.VRDESCONTO)/FINALTAB.NROPESSOAS, 2) 
                ELSE 0
            END AS TICKETMEDIO,
            CASE WHEN FINALTAB.NROPESSOAS > 0 THEN ROUND((VRTXENTREGA + VRGORJETA + FINALTAB.VALOR_FATURAMENTO + FINALTAB.VRACRESCIMO - FINALTAB.VRDESCONTO) / FINALTAB.NROPESSOAS, 2) ELSE 0 END AS TICKETMEDIOTAXA,
            (FINALTAB.VALOR_FATURAMENTO + FINALTAB.VRACRESCIMO - FINALTAB.VRDESCONTO) AS VALORLIQUIDOFINAL,
            ((FINALTAB.VALOR_FATURAMENTO + FINALTAB.VRACRESCIMO - FINALTAB.VRDESCONTO) + (FINALTAB.VRREPIQUE) + (FINALTAB.VRTXENTREGA) + (FINALTAB.VRGORJETA)) AS VRTOTALFINAL
            
             FROM (
            /*NESSA QUERY PRINCIPAL QUE FARA O AGRUPAMENTO, FALTA CALCULOS DOS TICKETS MEDIOS*/
            SELECT ".$GROUP.",
                TRUNC((SUM(NVL(TAB1.VALOR_FATURAMENTO, 0))+SUM(NVL(TAB1.VRCANCBRUTO, 0))+SUM(NVL(TAB2.VALOR_TOTAL, 0))+SUM(NVL(TAB3.VALOR_TOTAL, 0))), 2) AS FATURAMENTO_BRUTO, 
                TRUNC(SUM(NVL(TAB1.VALOR_FATURAMENTO, 0)), 2) AS VALOR_FATURAMENTO,
                SUM(NVL(TAB1.VRACRESCIMO, 0)) AS VRACRESCIMO,
                SUM(NVL(TAB1.VRDESCONTO, 0)) AS VRDESCONTO,
                SUM(NVL(TAB1.VRREPIQUE, 0)) AS VRREPIQUE,
                SUM(NVL(TAB3.VALOR_TOTAL, 0) - NVL(TAB3.VALOR_DESC, 0)) AS VRTXENTREGA, 
                SUM(NVL(TAB3.VALOR_DESC, 0)) AS DESC_VRTXENTREGA,
                SUM(NVL(TAB2.VALOR_TOTAL, 0) - NVL(TAB2.VALOR_DESC, 0)) AS VRGORJETA,
                SUM(NVL(TAB2.VALOR_DESC, 0)) AS DESC_VRGORJETA,
                SUM(NVL(TAB1.VRCANCELAMENTO, 0)) AS VRCANCELAMENTO,
                SUM(NVL(TAB1.VRCANCBRUTO, 0)) AS VRCANCBRUTO,
                SUM(TAB1.NROPESSOAS) AS NROPESSOAS,		 
                SUM(NVL(TAB1.QTD_TOTAL, 0) + NVL(TAB2.QTD_TOTAL, 0) + NVL(TAB3.QTD_TOTAL, 0)) AS QTD_TOTAL
            FROM (
                        
                ".self::TOTAL_MOD_DIA."  
            
                ) TAB1
            LEFT JOIN (
            
                ".self::TOTAL_GORJETA."  
            
            ) TAB2
                ON TAB1.CDFILIAL = TAB2.CDFILIAL
                ".$ONTAB2."
                AND TAB1.DTENTRVENDA = TAB2.DTENTRVENDA
                AND TAB1.MODALIDADE = TAB2.MODALIDADE
            LEFT JOIN (		
                
                ".self::TOTAL_TX_ENTREGA."  
                
            ) TAB3
                ON TAB1.CDFILIAL = TAB3.CDFILIAL
                ".$ONTAB3."
                AND TAB1.DTENTRVENDA = TAB3.DTENTRVENDA
                AND TAB1.MODALIDADE = TAB3.MODALIDADE
            GROUP BY 
                    ".$GROUP_BY." 
            ORDER BY      
                    ".$ORDER_BY.") FINALTAB ";
        
        return strval(trim($query));
    }
    
    const TOTAL_MOD_DIA = "
        SELECT CDFILIAL, NMFILIAL, CDNVPRODUTO1, NMNVPRODUTO1, CDNVPRODUTO2, NMNVPRODUTO2, 
                    CDNVPRODUTO3, NMNVPRODUTO3, CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5, 
                    MODALIDADE, DTENTRVENDA,
                    SUM(VRDESCONTO) AS VRDESCONTO,
                    SUM(VRACRESCIMO) AS VRACRESCIMO,
                    SUM(VRCANCELAMENTO) AS VRCANCELAMENTO,
                    SUM(VRCANCBRUTO) AS VRCANCBRUTO,
                    SUM(VALOR_FATURAMENTO) AS VALOR_FATURAMENTO,
                    SUM(QTD_TOTAL) AS QTD_TOTAL,
                    SUM(VRREPIQUE) AS VRREPIQUE,
                    SUM(NROPESSOAS) AS NROPESSOAS
                FROM
                    (
                        /*VALOR REPIQUE E O NºPESSOAS ATENDIDAS por DIA/MODALIDADE -> Só aceitas*/ 
                        SELECT A.CDFILIAL, A.NMFILIAL, A.CDNVPRODUTO1, A.NMNVPRODUTO1, 
                        A.CDNVPRODUTO2, A.NMNVPRODUTO2, A.CDNVPRODUTO3, A.NMNVPRODUTO3, 
                        A.CDNVPRODUTO4, A.NMNVPRODUTO4, A.CDNVPRODUTO5, A.NMNVPRODUTO5, 
                        A.MODALIDADE, A.CDCAIXA, 
                        A.DTENTRVENDA, SUM(A.NROPESSOAS) AS NROPESSOAS, SUM(A.VRREPIQUE) AS VRREPIQUE, 
                        SUM(A.VRDESCONTO) AS VRDESCONTO, SUM(A.VRACRESCIMO) AS VRACRESCIMO, SUM(A.VALOR_FATURAMENTO) AS VALOR_FATURAMENTO,
                        SUM(A.QTD_TOTAL) AS QTD_TOTAL, SUM(A.VRCANCELAMENTO) AS VRCANCELAMENTO, SUM(A.VRCANCBRUTO) AS VRCANCBRUTO
                        FROM
                        (
                            SELECT CDFILIAL, NMFILIAL, NRSEQVENDA, CDCAIXA, MODALIDADE, 
                                CDNVPRODUTO1, CDNVPRODUTO2, CDNVPRODUTO3, CDNVPRODUTO4, CDNVPRODUTO5, 
                                NMNVPRODUTO1, NMNVPRODUTO2, NMNVPRODUTO3, NMNVPRODUTO4, NMNVPRODUTO5,
                                DTENTRVENDA,
                                SUM(VRREPIQUE) AS VRREPIQUE,
                                CASE :IDGRPNVL
                                    WHEN 'S' THEN
                                         SUM(NROPESSOAS/NVL(NUMITENS, 1))
                                    ELSE
                                        SUM(NROPESSOAS) 
                                END AS NROPESSOAS,
                                0 AS VRDESCONTO,
                                0 AS VRACRESCIMO,
                                0 AS VALOR_FATURAMENTO,
                                0 AS QTD_TOTAL,
                                0 AS VRCANCELAMENTO,
                                0 AS VRCANCBRUTO
                            FROM
                                (
                            WITH FLC AS 
                                (".self::GET_VFILIALLOJACAIXA.") 
                                SELECT V.CDFILIAL, FLC.NMFILIAL, V.NRSEQVENDA, COUNT(*) OVER (PARTITION BY V.NRSEQVENDA) AS NUMITENS,
                                                NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                                P.CDNVPRODUTO AS CDNVPRODUTO1, P.NMPRODUTO AS NMNVPRODUTO1,
                                                P1.CDNVPRODUTO AS CDNVPRODUTO2, P1.NMPRODUTO AS NMNVPRODUTO2,
                                                P2.CDNVPRODUTO AS CDNVPRODUTO3, P2.NMPRODUTO AS NMNVPRODUTO3,
                                                P3.CDNVPRODUTO AS CDNVPRODUTO4, P3.NMPRODUTO AS NMNVPRODUTO4,
                                                P4.CDNVPRODUTO AS CDNVPRODUTO5, P4.NMPRODUTO AS NMNVPRODUTO5,
                                                (NVL(V.NRPESMESAVENDA, 1)) AS NROPESSOAS,
                                                (NVL(V.VRREPIQUEVENDA, 0)) AS VRREPIQUE,
                                                V.DTENTRVENDA, V.CDCAIXA
                                            FROM VENDA V
                                                JOIN FLC
                                                    ON V.CDFILIAL = FLC.CDFILIAL
                                                        AND V.CDCAIXA = FLC.CDCAIXA
                                                        AND V.CDLOJA = FLC.CDLOJA
                                                LEFT JOIN ITEMVENDA ITV
                                                    ON V.CDFILIAL = ITV.CDFILIAL
                                                        AND V.CDCAIXA = ITV.CDCAIXA
                                                        AND V.NRSEQVENDA = ITV.NRSEQVENDA
                                                        AND :IDGRPNVL = 'S'
                                                LEFT JOIN PRODUTO P4
                                                    ON P4.CDPRODUTO = ITV.CDPRODUTO
                                                    AND :IDGRPNVL = 'S'
                                                LEFT JOIN PRODUTO P3
                                                        ON P4.CDPRODNIVANTE = P3.CDARVPROD
                                                        AND :IDGRPNVL = 'S'
                                                LEFT JOIN PRODUTO P2
                                                        ON P3.CDPRODNIVANTE = P2.CDARVPROD
                                                        AND :IDGRPNVL = 'S'
                                                LEFT JOIN PRODUTO P1
                                                        ON P2.CDPRODNIVANTE = P1.CDARVPROD
                                                        AND :IDGRPNVL = 'S'
                                                LEFT JOIN PRODUTO P
                                                        ON P1.CDPRODNIVANTE = P.CDARVPROD 
                                                        AND :IDGRPNVL = 'S'
                                                JOIN ORIGEMVENDAFOS O
                                                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                                        AND V.NRORG = O.NRORG
                                            WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                                AND ((V.IDSITUVENDA IN(CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                                                        WHEN 'AJU' THEN V.IDSITUVENDA
                                                                       END)) 
                                                  OR ((INSTR(:IDSITUVENDA, V.IDSITUVENDA) <> 0)) 
                                                  OR (:IDSITUVENDA = 'T'))
                                                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                                AND V.IDORIGEMVENDA <> (CASE :FLAGBALTAA
                                                                            WHEN 'S' THEN 'BAL_AUT'
                                                                            ELSE 'ZZZZZZ'
                                                                        END)
                                                AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                                                 ORDER BY CDFILIAL, NMFILIAL, NRSEQVENDA, CDCAIXA, 
                                                        MODALIDADE, DTENTRVENDA, P.NMPRODUTO, P1.NMPRODUTO, P2.NMPRODUTO, P3.NMPRODUTO, P4.NMPRODUTO
                                )
                            GROUP BY CDFILIAL, NMFILIAL, NRSEQVENDA, CDCAIXA, 
                                    MODALIDADE, DTENTRVENDA, CDNVPRODUTO1, NMNVPRODUTO1,
                                    CDNVPRODUTO2, NMNVPRODUTO2, CDNVPRODUTO3, NMNVPRODUTO3,
                                    CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5, NROPESSOAS
                        ) A
                        GROUP BY A.CDFILIAL, A.NMFILIAL, A.CDCAIXA, 
                                    A.MODALIDADE, A.DTENTRVENDA, A.CDNVPRODUTO1, A.NMNVPRODUTO1, A.CDNVPRODUTO2, A.NMNVPRODUTO2, 
                                    A.CDNVPRODUTO3, A.NMNVPRODUTO3, A.CDNVPRODUTO4, A.NMNVPRODUTO4, A.CDNVPRODUTO5, A.NMNVPRODUTO5
        	        UNION 
                    /*ITEMVENDA UNIAO DOS DOIS ABAIXO*/ /*VALORES DE ACRESCIMO, DESCONTO, VALOR_VENDIDO, VALOR_TOTAL, VALOR_FATURAMENTO, QTD_TOTAL DIA/MODALIDADE -> Só aceitas*/
                        SELECT CDFILIAL, NMFILIAL, 
                                CDNVPRODUTO1, NMNVPRODUTO1,CDNVPRODUTO2, NMNVPRODUTO2, 
                                CDNVPRODUTO3, NMNVPRODUTO3, CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5, 
                                MODALIDADE,
                                CDCAIXA,
                                DTENTRVENDA,
                                0 AS VRREPIQUE,
                                0 AS NROPESSOAS,
                                SUM(VRDESCONTO) AS VRDESCONTO,
                                SUM(VRACRESCIMO) AS VRACRESCIMO,
                                SUM(VALOR_FATURAMENTO) AS VALOR_FATURAMENTO,
                                SUM(QTD_TOTAL) AS QTD_TOTAL,
                                0 AS VRCANCELAMENTO,
                                0 AS VRCANCBRUTO
                        FROM
                            (
                        WITH FLC AS
                                (".self::GET_VFILIALLOJACAIXA.") 
                                SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, V.DTENTRVENDA,
                                            P.CDNVPRODUTO AS CDNVPRODUTO1, P.NMPRODUTO AS NMNVPRODUTO1,
                                            P1.CDNVPRODUTO AS CDNVPRODUTO2, P1.NMPRODUTO AS NMNVPRODUTO2,
                                            P2.CDNVPRODUTO AS CDNVPRODUTO3, P2.NMPRODUTO AS NMNVPRODUTO3,
                                            P3.CDNVPRODUTO AS CDNVPRODUTO4, P3.NMPRODUTO AS NMNVPRODUTO4,
                                            P4.CDNVPRODUTO AS CDNVPRODUTO5, P4.NMPRODUTO AS NMNVPRODUTO5,
                                            NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                            FLC.NMFILIAL,
                                            CASE V.IDSITUVENDA
                                                WHEN 'C' THEN 0
                                                ELSE SUM(TRUNC(NVL(ITV.VRDESITVEND, 0), 2)) 
                                            END AS VRDESCONTO,
                                            CASE V.IDSITUVENDA
                                                WHEN 'C' THEN 0
                                                ELSE SUM(TRUNC(NVL(ITV.VRACRITVEND, 0), 2))
                                            END AS VRACRESCIMO,
                                            CASE V.IDSITUVENDA
                                                WHEN 'C' THEN 0
                                                ELSE SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2))
                                            END AS VALOR_FATURAMENTO,
                                            SUM(ITV.QTPRODVEND) AS QTD_TOTAL
                                        FROM VENDA V
                                            JOIN FLC
                                                ON V.CDFILIAL = FLC.CDFILIAL
                                                    AND V.CDCAIXA = FLC.CDCAIXA
                                                    AND V.CDLOJA = FLC.CDLOJA
                                            JOIN ITEMVENDA ITV
                                                ON V.CDFILIAL = ITV.CDFILIAL
                                                    AND V.CDCAIXA = ITV.CDCAIXA
                                                    AND V.NRSEQVENDA = ITV.NRSEQVENDA
                                            LEFT JOIN PRODUTO P4
                                                ON P4.CDPRODUTO = ITV.CDPRODUTO
                                                AND :IDGRPNVL = 'S'
                                            LEFT JOIN PRODUTO P3
                                                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                                                    AND :IDGRPNVL = 'S'
                                            LEFT JOIN PRODUTO P2
                                                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                                                    AND :IDGRPNVL = 'S'
                                            LEFT JOIN PRODUTO P1
                                                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
                                                    AND :IDGRPNVL = 'S'
                                            LEFT JOIN PRODUTO P
                                                    ON P1.CDPRODNIVANTE = P.CDARVPROD
                                                    AND :IDGRPNVL = 'S'
                                            LEFT JOIN ORIGEMVENDAFOS O
                                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                                    AND V.NRORG = O.NRORG
                                WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                    AND ((V.IDSITUVENDA IN(CASE SUBSTR(V.IDORIGEMVENDA, 0, 3)
                                                            WHEN 'AJU' THEN V.IDSITUVENDA
                                                           END)) 
                                      OR ((INSTR(:IDSITUVENDA, V.IDSITUVENDA) <> 0)) 
                                      OR (:IDSITUVENDA = 'T'))
                                    AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                    AND V.IDORIGEMVENDA <> (CASE :FLAGBALTAA
                                                                WHEN 'S' THEN 'BAL_AUT'
                                                                ELSE 'ZZZZZZ'
                                                            END)
                                    AND ITV.CDPRODUTO <> (CASE 
                                                            WHEN (FLC.IDTRATTAXAENTR = 'P' AND SUBSTR(V.IDORIGEMVENDA, 0, 3) = 'DLV') 
                                                                THEN FLC.CDPRODTAXAENTR
                                                            ELSE 'ZZZZZZZ'
                                                        END)
                                    AND ITV.CDPRODUTO <> (CASE 
                                                            WHEN (FLC.IDTRATTAXASERV = 'P' AND FLC.IDCOMISVENDA IN ('S', 'G')) 
                                                                THEN FLC.CDPRODTAXASERV
                                                            ELSE 'ZZZZZZZ'
                                                        END)
                                    AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                                GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, O.DSORIGEMVENDA,
                                        ITV.NRSEQVENDA, V.IDSITUVENDA,
                                        V.DTENTRVENDA, FLC.NMFILIAL, P.CDNVPRODUTO, P.NMPRODUTO,
                                        P1.CDNVPRODUTO, P1.NMPRODUTO, P2.CDNVPRODUTO, P2.NMPRODUTO, P3.CDNVPRODUTO, P3.NMPRODUTO,
                                        P4.CDNVPRODUTO, P4.NMPRODUTO
                            )
                        GROUP BY CDFILIAL, NMFILIAL, CDCAIXA,
                                MODALIDADE, CDNVPRODUTO1, NMNVPRODUTO1,
                                    CDNVPRODUTO2, NMNVPRODUTO2, CDNVPRODUTO3, NMNVPRODUTO3,
                                    CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5, DTENTRVENDA
                    UNION  
                    /*VALORES DE CANCELAMENTO -> Itens Cancelados e vendas canceladas */
                        SELECT CDFILIAL, NMFILIAL, 
                                CDNVPRODUTO1, NMNVPRODUTO1, CDNVPRODUTO2, NMNVPRODUTO2, 
                                CDNVPRODUTO3, NMNVPRODUTO3, CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5, 
                                MODALIDADE,
                                CDCAIXA,
                                DTENTRVENDA, 0 AS VRREPIQUE,
                                0 AS NROPESSOAS, 0 AS VRDESCONTO,
                                0 AS VRACRESCIMO, 0 AS VALOR_FATURAMENTO,
                                0 AS QTD_TOTAL, SUM(VRCANCELAMENTO) AS VRCANCELAMENTO,
                                SUM(VRCANCBRUTO) AS VRCANCBRUTO
                        FROM
                            (
                            WITH FLC AS
                            (".self::GET_VFILIALLOJACAIXA.") 
                            SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, 
                                P.CDNVPRODUTO AS CDNVPRODUTO1, P.NMPRODUTO AS NMNVPRODUTO1,
                                P1.CDNVPRODUTO AS CDNVPRODUTO2, P1.NMPRODUTO AS NMNVPRODUTO2,
                                P2.CDNVPRODUTO AS CDNVPRODUTO3, P2.NMPRODUTO AS NMNVPRODUTO3,
                                P3.CDNVPRODUTO AS CDNVPRODUTO4, P3.NMPRODUTO AS NMNVPRODUTO4,
                                P4.CDNVPRODUTO AS CDNVPRODUTO5, P4.NMPRODUTO AS NMNVPRODUTO5,
                                NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                V.DTENTRVENDA, FLC.NMFILIAL,
                                SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) + NVL(ITV.VRACRITVEND, 0) - NVL(ITV.VRDESITVEND, 0)) AS VRCANCELAMENTO,
                                SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) + NVL(ITV.VRACRITVEND, 0)) AS VRCANCBRUTO,
                                SUM(ITV.QTPRODVEND) AS QTD_TOTAL
                            FROM VENDA V
                                JOIN FLC
                                    ON V.CDFILIAL = FLC.CDFILIAL
                                        AND V.CDCAIXA = FLC.CDCAIXA
                                        AND V.CDLOJA = FLC.CDLOJA
                                JOIN ITEMVENDA ITV
                                    ON V.CDFILIAL = ITV.CDFILIAL
                                        AND V.CDCAIXA = ITV.CDCAIXA
                                        AND V.NRSEQVENDA = ITV.NRSEQVENDA
                                LEFT JOIN PRODUTO P4
                                    ON P4.CDPRODUTO = ITV.CDPRODUTO
                                    AND :IDGRPNVL = 'S'
                                LEFT JOIN PRODUTO P3
                                        ON P4.CDPRODNIVANTE = P3.CDARVPROD
                                        AND :IDGRPNVL = 'S'
                                LEFT JOIN PRODUTO P2
                                        ON P3.CDPRODNIVANTE = P2.CDARVPROD
                                        AND :IDGRPNVL = 'S'
                                LEFT JOIN PRODUTO P1
                                        ON P2.CDPRODNIVANTE = P1.CDARVPROD
                                        AND :IDGRPNVL = 'S'
                                LEFT JOIN PRODUTO P
                                        ON P1.CDPRODNIVANTE = P.CDARVPROD 
                                        AND :IDGRPNVL = 'S'
                                LEFT JOIN ORIGEMVENDAFOS O
                                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                        AND V.NRORG = O.NRORG
                            WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                AND (V.IDSITUVENDA IN (CASE :IDVENDACAN
                                                        WHEN 'O' THEN 'ZZZZZ'
                                                            ELSE 'C'
                                                        END) OR (V.IDSITUVENDA = 'T'))
                                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                            GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA,
                                    O.DSORIGEMVENDA, V.DTENTRVENDA, FLC.NMFILIAL,P.CDNVPRODUTO, P.NMPRODUTO,
                                    P1.CDNVPRODUTO, P1.NMPRODUTO, P2.CDNVPRODUTO, P2.NMPRODUTO, P3.CDNVPRODUTO, P3.NMPRODUTO,
                                    P4.CDNVPRODUTO, P4.NMPRODUTO
                            UNION 
                            SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, P.CDNVPRODUTO AS CDNVPRODUTO1, P.NMPRODUTO AS NMNVPRODUTO1,
                                P1.CDNVPRODUTO AS CDNVPRODUTO2, P1.NMPRODUTO AS NMNVPRODUTO2,
                                P2.CDNVPRODUTO AS CDNVPRODUTO3, P2.NMPRODUTO AS NMNVPRODUTO3,
                                P3.CDNVPRODUTO AS CDNVPRODUTO4, P3.NMPRODUTO AS NMNVPRODUTO4,
                                P4.CDNVPRODUTO AS CDNVPRODUTO5, P4.NMPRODUTO AS NMNVPRODUTO5,
                                NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                V.DTENTRVENDA, FLC.NMFILIAL,
                                SUM(TRUNC(ITV.QTPRODVENDC * (ITV.VRUNITVENDC + NVL(ITV.VRUNITVENCLC, 0)), 2) + NVL(ITV.VRACRITVENDC, 0) - NVL(ITV.VRDESITVENDC, 0)) AS VRCANCELAMENTO,
                                SUM(TRUNC(ITV.QTPRODVENDC * (ITV.VRUNITVENDC + NVL(ITV.VRUNITVENCLC, 0)), 2) + NVL(ITV.VRACRITVENDC, 0)) AS VRCANCBRUTO,
                                SUM(ITV.QTPRODVENDC) AS QTD_TOTAL
                            FROM VENDA V
                            JOIN (".self::GET_VFILIALLOJACAIXA.") FLC
                            ON V.CDFILIAL = FLC.CDFILIAL
                                    AND V.CDCAIXA = FLC.CDCAIXA
                                    AND V.CDLOJA = FLC.CDLOJA
                            JOIN ITVENDACAN ITV
                                ON V.CDFILIAL = ITV.CDFILIAL
                                    AND V.CDCAIXA = ITV.CDCAIXA
                                    AND V.NRSEQVENDA = ITV.NRSEQVENDA
                            LEFT JOIN PRODUTO P4
                                ON P4.CDPRODUTO = ITV.CDPRODUTO
                                AND :IDGRPNVL = 'S'
                            LEFT JOIN PRODUTO P3
                                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                                    AND :IDGRPNVL = 'S'
                            LEFT JOIN PRODUTO P2
                                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                                    AND :IDGRPNVL = 'S'
                            LEFT JOIN PRODUTO P1
                                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
                                    AND :IDGRPNVL = 'S'
                            LEFT JOIN PRODUTO P
                                    ON P1.CDPRODNIVANTE = P.CDARVPROD 
                                    AND :IDGRPNVL = 'S'
                            LEFT JOIN ORIGEMVENDAFOS O
                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                    AND V.NRORG = O.NRORG
                        WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                            AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                        GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA,
                                O.DSORIGEMVENDA, V.DTENTRVENDA, FLC.NMFILIAL, P.CDNVPRODUTO, P.NMPRODUTO,
                                P1.CDNVPRODUTO, P1.NMPRODUTO, P2.CDNVPRODUTO, P2.NMPRODUTO, P3.CDNVPRODUTO, P3.NMPRODUTO,
                                P4.CDNVPRODUTO, P4.NMPRODUTO
                        )
                        GROUP BY CDFILIAL, NMFILIAL, CDCAIXA,
                                MODALIDADE, DTENTRVENDA, CDNVPRODUTO1, NMNVPRODUTO1,
                                CDNVPRODUTO2, NMNVPRODUTO2, CDNVPRODUTO3, NMNVPRODUTO3,
                                CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5
                    ) VENDMODDIA
                GROUP BY CDFILIAL, NMFILIAL,
                           MODALIDADE, DTENTRVENDA, CDNVPRODUTO1, NMNVPRODUTO1,
                            CDNVPRODUTO2, NMNVPRODUTO2, CDNVPRODUTO3, NMNVPRODUTO3,
                            CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5
            ORDER BY CDFILIAL, NMFILIAL, MODALIDADE, DTENTRVENDA, CDNVPRODUTO1, NMNVPRODUTO1,
                                    CDNVPRODUTO2, NMNVPRODUTO2, CDNVPRODUTO3, NMNVPRODUTO3,
                                    CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5
    ";
    
    
    const TOTAL_GORJETA = "
        /*CALCULO GORJETA QUANDO PRODUTO TRATADO/PARAMETRIZADO PARA TAL CALCULO, NAO PODE SER NA MODALIDADE DELIVERY, SO ACEITAS */
        SELECT TB2.CDFILIAL, TB2.CDNVPRODUTO1, TB2.NMNVPRODUTO1, TB2.CDNVPRODUTO2, TB2.NMNVPRODUTO2, 
            TB2.CDNVPRODUTO3, TB2.NMNVPRODUTO3, TB2.CDNVPRODUTO4, TB2.NMNVPRODUTO4, TB2.CDNVPRODUTO5, TB2.NMNVPRODUTO5, 
            '', TB2.DTENTRVENDA, TB2.MODALIDADE, SUM(TB2.QTD_TOTAL) AS QTD_TOTAL, TRUNC(SUM(TB2.VALOR_TOTAL), 2) AS VALOR_TOTAL, 
            TRUNC(SUM(TB2.VALOR_DESC), 2) AS VALOR_DESC
        FROM ( 
            SELECT V.CDFILIAL,
                P.CDNVPRODUTO AS CDNVPRODUTO1, P.NMPRODUTO AS NMNVPRODUTO1,
                P1.CDNVPRODUTO AS CDNVPRODUTO2, P1.NMPRODUTO AS NMNVPRODUTO2,
                P2.CDNVPRODUTO AS CDNVPRODUTO3, P2.NMPRODUTO AS NMNVPRODUTO3,
                P3.CDNVPRODUTO AS CDNVPRODUTO4, P3.NMPRODUTO AS NMNVPRODUTO4,
                P4.CDNVPRODUTO AS CDNVPRODUTO5, P4.NMPRODUTO AS NMNVPRODUTO5,
                '', V.DTENTRVENDA, NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE, 
                SUM(I.QTPRODVEND) AS QTD_TOTAL, 
                (SUM(TRUNC(NVL(I.QTPRODVEND, 0) * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2)) + SUM(NVL(I.VRACRITVEND,0))) AS VALOR_TOTAL, 
                SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VALOR_DESC
            FROM VENDA V
                JOIN (".self::GET_VFILIALLOJACAIXA.") FLC
                    ON V.CDFILIAL = FLC.CDFILIAL
                        AND V.CDCAIXA = FLC.CDCAIXA
                        AND V.CDLOJA = FLC.CDLOJA
                JOIN ITEMVENDA I
                    ON V.NRSEQVENDA = I.NRSEQVENDA
                        AND V.CDCAIXA = I.CDCAIXA
                        AND V.CDFILIAL = I.CDFILIAL
                        AND I.CDPRODUTO = FLC.CDPRODTAXASERV
                LEFT JOIN PRODUTO P4
                    ON P4.CDPRODUTO = I.CDPRODUTO
                    AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P3
                        ON P4.CDPRODNIVANTE = P3.CDARVPROD
                        AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P2
                        ON P3.CDPRODNIVANTE = P2.CDARVPROD
                        AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P1
                        ON P2.CDPRODNIVANTE = P1.CDARVPROD
                        AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P
                        ON P1.CDPRODNIVANTE = P.CDARVPROD 
                        AND :IDGRPNVL = 'S'
                LEFT JOIN ORIGEMVENDAFOS O
                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                        AND V.NRORG = O.NRORG
            WHERE FLC.IDCOMISVENDA IN ('S', 'G')      
                AND FLC.IDTRATTAXASERV = 'P'                             
                AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                AND V.IDSITUVENDA = 'O'               
                AND SUBSTR(V.IDORIGEMVENDA, 0, 3) <> 'DLV'   
                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                AND O.IDORIGEMVENDA <> (CASE :FLAGBALTAA WHEN 'S' THEN 'BAL_AUT' ELSE 'ZZZZZZ' END)	
                AND V.IDTPAMBNFCE = :IDTPAMBNFCE		 
            GROUP BY V.CDFILIAL, V.DTENTRVENDA, O.DSORIGEMVENDA, P.CDNVPRODUTO, P.NMPRODUTO,
                P1.CDNVPRODUTO, P1.NMPRODUTO, P2.CDNVPRODUTO, P2.NMPRODUTO, P3.CDNVPRODUTO, P3.NMPRODUTO,
                P4.CDNVPRODUTO, P4.NMPRODUTO
        ) TB2
        GROUP BY TB2.CDFILIAL, TB2.DTENTRVENDA, TB2.MODALIDADE, TB2.CDNVPRODUTO1, TB2.NMNVPRODUTO1,
                TB2.CDNVPRODUTO2, TB2.NMNVPRODUTO2, TB2.CDNVPRODUTO3, TB2.NMNVPRODUTO3,
                TB2.CDNVPRODUTO4, TB2.NMNVPRODUTO4, TB2.CDNVPRODUTO5, TB2.NMNVPRODUTO5
    ";
   
    const TOTAL_TX_ENTREGA = "
        /*CALCULO TAXA DE ENTREGA QUANDO PRODUTO TRATADO/PARAMETRIZADO PARA TAL CALCULO, MODALIDADE DELIVERY, SO ACEITAS */
        SELECT CDFILIAL, CDNVPRODUTO1, NMNVPRODUTO1, CDNVPRODUTO2, NMNVPRODUTO2, CDNVPRODUTO3, NMNVPRODUTO3, 
            CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5, 
            '', DTENTRVENDA, MODALIDADE, SUM(QTD_TOTAL) AS QTD_TOTAL, TRUNC(SUM(VALOR_TOTAL), 2) AS VALOR_TOTAL, TRUNC(SUM(VALOR_DESC), 2) AS VALOR_DESC 
        FROM (
            SELECT V.CDFILIAL, P.CDNVPRODUTO AS CDNVPRODUTO1, P.NMPRODUTO AS NMNVPRODUTO1,
                P1.CDNVPRODUTO AS CDNVPRODUTO2, P1.NMPRODUTO AS NMNVPRODUTO2,
                P2.CDNVPRODUTO AS CDNVPRODUTO3, P2.NMPRODUTO AS NMNVPRODUTO3,
                P3.CDNVPRODUTO AS CDNVPRODUTO4, P3.NMPRODUTO AS NMNVPRODUTO4,
                P4.CDNVPRODUTO AS CDNVPRODUTO5, P4.NMPRODUTO AS NMNVPRODUTO5,
                '', V.DTENTRVENDA, NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                SUM(I.QTPRODVEND) AS QTD_TOTAL, 
                (SUM(TRUNC(NVL(I.QTPRODVEND, 0) * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2)) + SUM(NVL(I.VRACRITVEND,0))) AS VALOR_TOTAL, 
                SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VALOR_DESC
            FROM VENDA V
                JOIN (".self::GET_VFILIALLOJACAIXA.") FLC
                    ON V.CDFILIAL = FLC.CDFILIAL
                        AND V.CDCAIXA = FLC.CDCAIXA
                        AND V.CDLOJA = FLC.CDLOJA
                JOIN ITEMVENDA I
                    ON V.NRSEQVENDA = I.NRSEQVENDA
                        AND V.CDCAIXA = I.CDCAIXA
                        AND V.CDFILIAL = I.CDFILIAL
                        AND I.CDPRODUTO = FLC.CDPRODTAXAENTR
                LEFT JOIN PRODUTO P4
                    ON P4.CDPRODUTO = I.CDPRODUTO
                    AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P3
                        ON P4.CDPRODNIVANTE = P3.CDARVPROD
                        AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P2
                        ON P3.CDPRODNIVANTE = P2.CDARVPROD
                        AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P1
                        ON P2.CDPRODNIVANTE = P1.CDARVPROD
                        AND :IDGRPNVL = 'S'
                LEFT JOIN PRODUTO P
                        ON P1.CDPRODNIVANTE = P.CDARVPROD 
                        AND :IDGRPNVL = 'S'
                LEFT JOIN ORIGEMVENDAFOS O
                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                        AND V.NRORG = O.NRORG
            WHERE FLC.IDTRATTAXAENTR = 'P'
                AND SUBSTR(V.IDORIGEMVENDA, 0, 3) = 'DLV'
                AND V.IDSITUVENDA = 'O'
                AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                AND O.IDORIGEMVENDA <> (CASE :FLAGBALTAA WHEN 'S' THEN 'BAL_AUT' ELSE 'ZZZZZZ' END)
                AND V.IDTPAMBNFCE = :IDTPAMBNFCE
            GROUP BY V.CDFILIAL, V.DTENTRVENDA, O.DSORIGEMVENDA, P.CDNVPRODUTO, P.NMPRODUTO,
                    P1.CDNVPRODUTO, P1.NMPRODUTO, P2.CDNVPRODUTO, P2.NMPRODUTO, P3.CDNVPRODUTO, P3.NMPRODUTO,
                    P4.CDNVPRODUTO, P4.NMPRODUTO
        )
        GROUP BY CDFILIAL, DTENTRVENDA, MODALIDADE, CDNVPRODUTO1, NMNVPRODUTO1,
                CDNVPRODUTO2, NMNVPRODUTO2, CDNVPRODUTO3, NMNVPRODUTO3,
                CDNVPRODUTO4, NMNVPRODUTO4, CDNVPRODUTO5, NMNVPRODUTO5 
    ";
    
    const GROUP_MOD_DIA_ANA = "
         TAB1.CDFILIAL, TAB1.NMFILIAL, TO_CHAR(TAB1.DTENTRVENDA, 'DD/MM/YYYY') AS DATA,
         TAB1.MODALIDADE AS MODALIDADE";
         
    const GROUP_MOD_DIA_SIN = "
          TAB1.CDFILIAL, TAB1.NMFILIAL, TO_CHAR(TAB1.DTENTRVENDA, 'DD/MM/YYYY') AS DATA,
         'TODOS' AS MODALIDADE";
   
   const GROUP_MOD_TODOS = "TAB1.CDFILIAL, TAB1.NMFILIAL, 'TODAS' AS MODALIDADE";
   
  
    const GET_FATURAMENTODELIVERY_GERAL_ANALITICO = "
      SELECT TAB1.CDFILIAL || ' - ' || TAB1.NMFILIAL AS CODFILIAL,
            TAB1.CDFILIAL AS CODIGOFILIAL,
            TAB1.MODALIDADE AS MODALIDADE, 
            NVL(TAB1.VALOR_TOTAL, 0) - NVL(TAB2.VALOR_TOTAL, 0) AS VRVENDA,
            NVL(TAB2.VALOR_TOTAL, 0) AS VRTXENTREGA,
            NVL(TAB1.VALOR_TOTAL, 0) AS VRTOTAL,
            TAB1.NROPESSOAS,
            TRUNC((NVL(TAB1.VALOR_TOTAL, 0)) / TAB1.NROPESSOAS, 2) AS TICKETMEDIO
        FROM (
                SELECT VENDA.CDFILIAL, VENDA.NMFILIAL, VENDA.MODALIDADE,
                        SUM(ITEMVENDA.VALOR_TOTAL) AS VALOR_TOTAL,
                        VENDA.NROPESSOAS AS NROPESSOAS
                    FROM (
                            SELECT CDFILIAL, NMFILIAL, NRORG, MODALIDADE, SUM(NROPESSOAS) AS NROPESSOAS 
                            FROM (
                                    SELECT V.CDFILIAL, F.NMFILIAL, V.NRSEQVENDA,
                                            NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                            SUM(NVL(V.NRPESMESAVENDA, 1)) AS NROPESSOAS,
                                            V.NRORG, V.CDCAIXA
                                        FROM VENDA V
                                            JOIN FILIAL F
                                                ON V.CDFILIAL = F.CDFILIAL
                                                    AND V.NRORG   = F.NRORG
                                            LEFT JOIN ORIGEMVENDAFOS O
                                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                                    AND V.NRORG = O.NRORG
                                        WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                                            AND ((INSTR(:CDLOJA, V.CDFILIAL ||V.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))
                                            AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                            AND V.IDSITUVENDA = 'O'
                                            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                            AND V.NRORG = :NRORG
                                        GROUP BY V.CDFILIAL, F.NMFILIAL, V.NRSEQVENDA, O.DSORIGEMVENDA, V.NRORG, V.CDCAIXA
                            )
                            GROUP BY CDFILIAL, NMFILIAL, MODALIDADE, NRORG
                    ) VENDA
                        JOIN (
                            SELECT CDFILIAL, MODALIDADE, CDCAIXA, NRORG, SUM(VALOR_TOTAL) AS VALOR_TOTAL 
                            FROM (
                                SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA,
                                        NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                        ITV.NRORG,
                                        SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) - NVL(ITV.VRDESITVEND, 0) + NVL(ITV.VRACRITVEND, 0)) AS VALOR_TOTAL
                                    FROM VENDA V
                                        JOIN ITEMVENDA ITV
                                            ON V.CDFILIAL = ITV.CDFILIAL
                                                AND V.CDCAIXA = ITV.CDCAIXA
                                                AND V.NRSEQVENDA = ITV.NRSEQVENDA  
                                                AND V.NRORG = ITV.NRORG
                                        LEFT JOIN ORIGEMVENDAFOS O
                                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                                    AND V.NRORG = O.NRORG
                                    WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                                        AND ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))
                                        AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                        AND V.IDSITUVENDA = 'O'
                                        AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                        AND V.NRORG = :NRORG
                                    GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, O.DSORIGEMVENDA, ITV.NRSEQVENDA, ITV.NRORG
                                ) 
                            GROUP BY CDFILIAL, MODALIDADE, CDCAIXA, NRORG
                        ) ITEMVENDA
                            ON VENDA.CDFILIAL = ITEMVENDA.CDFILIAL
                                AND VENDA.MODALIDADE = ITEMVENDA.MODALIDADE
                                AND VENDA.NRORG = ITEMVENDA.NRORG
                    GROUP BY VENDA.CDFILIAL, VENDA.NMFILIAL, VENDA.MODALIDADE, VENDA.NROPESSOAS
        ) TAB1
            LEFT JOIN (
                        SELECT V.CDFILIAL, '', 
                                NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                NVL(SUM(NVL(I.VRACRITVEND, 0)), 0) AS VALOR_TOTAL, 0
                        FROM ITEMVENDA I
                            JOIN LOJA L
                                ON I.CDPRODUTO = L.CDPRODTAXAENTR 
                                    AND I.NRORG = L.NRORG
                            JOIN VENDA V
                                ON L.CDLOJA = V.CDLOJA       
                                    AND L.CDFILIAL = V.CDFILIAL
                                    AND L.NRORG    = V.NRORG
                                    AND V.NRSEQVENDA  = I.NRSEQVENDA   
                                    AND V.CDCAIXA     = I.CDCAIXA
                                    AND V.CDFILIAL    = I.CDFILIAL     
                                    AND V.NRORG = I.NRORG
                            LEFT JOIN ORIGEMVENDAFOS O
                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                    AND V.NRORG = O.NRORG
                        WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                            AND L.IDTRATTAXAENTR = 'P'
                            AND ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                            AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                            AND V.IDSITUVENDA = 'O'            
                            AND I.NRORG = :NRORG
                            AND SUBSTR(V.IDORIGEMVENDA, 0, 3) = 'DLV'
                            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                        GROUP BY V.CDFILIAL, O.DSORIGEMVENDA
            ) TAB2
                ON TAB1.CDFILIAL = TAB2.CDFILIAL
                    AND TAB1.MODALIDADE = TAB2.MODALIDADE
    ORDER BY TAB1.CDFILIAL
    ";
  
    const GET_FATURAMENTODELIVERY_GERAL_SINTETICO = "
       SELECT TAB1.CDFILIAL || ' - ' || TAB1.NMFILIAL AS CODFILIAL, TAB1.CDFILIAL AS CODIGOFILIAL, 
            TAB1.MODALIDADE AS MODALIDADE,  
            NVL(TAB1.VALOR_TOTAL, 0) - NVL(TAB2.VALOR_TOTAL, 0) AS VRVENDA,
            NVL(TAB2.VALOR_TOTAL, 0) AS VRTXENTREGA, 
            NVL(TAB1.VALOR_TOTAL, 0) AS VRTOTAL, 
            TAB1.NROPESSOAS,
            TRUNC((NVL(TAB1.VALOR_TOTAL, 0)) / TAB1.NROPESSOAS, 2) AS TICKETMEDIO
        FROM (
            SELECT VENDA.CDFILIAL, VENDA.NMFILIAL, VENDA.MODALIDADE, 
                    SUM(ITEMVENDA.VALOR_TOTAL) AS VALOR_TOTAL, VENDA.NROPESSOAS AS NROPESSOAS
            FROM (
                SELECT CDFILIAL, NMFILIAL, NRORG, MODALIDADE, SUM(NROPESSOAS) AS NROPESSOAS 
                FROM (
                    SELECT V.CDFILIAL, F.NMFILIAL, V.NRSEQVENDA, 'TODOS' AS MODALIDADE, 
                            SUM(NVL(V.NRPESMESAVENDA, 1)) AS NROPESSOAS, V.NRORG, V.CDCAIXA
                        FROM VENDA V
                            JOIN FILIAL F
                                ON V.CDFILIAL   = F.CDFILIAL
                                    AND V.NRORG = F.NRORG
                            LEFT JOIN ORIGEMVENDAFOS O
                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                    AND V.NRORG = O.NRORG
                        WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                            AND ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))
                            AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                            AND V.IDSITUVENDA = 'O'
                            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                            AND V.NRORG = :NRORG
                        GROUP BY V.CDFILIAL, F.NMFILIAL, V.NRSEQVENDA, V.NRORG, V.CDCAIXA
                ) 
                GROUP BY CDFILIAL, NMFILIAL, MODALIDADE, NRORG
            ) VENDA
            JOIN (
                SELECT CDFILIAL, MODALIDADE, CDCAIXA, NRORG, SUM(VALOR_TOTAL) AS VALOR_TOTAL 
                    FROM (
                            SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, 'TODOS' AS MODALIDADE, ITV.NRORG,
                                    SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) - NVL(ITV.VRDESITVEND, 0) + NVL(ITV.VRACRITVEND, 0)) AS VALOR_TOTAL
                                FROM VENDA V
                                    JOIN ITEMVENDA ITV
                                        ON V.CDFILIAL = ITV.CDFILIAL
                                            AND V.CDCAIXA    = ITV.CDCAIXA
                                            AND V.NRSEQVENDA = ITV.NRSEQVENDA
                                            AND V.NRORG      = ITV.NRORG
                                    LEFT JOIN ORIGEMVENDAFOS O
                                        ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                            AND V.NRORG = O.NRORG
                                WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                                    AND ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))
                                    AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                    AND V.IDSITUVENDA = 'O'
                                    AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                    AND V.NRORG = :NRORG
                                GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, O.DSORIGEMVENDA, ITV.NRSEQVENDA, ITV.NRORG
                    ) 
                    GROUP BY CDFILIAL, MODALIDADE, CDCAIXA, NRORG
            ) ITEMVENDA
                ON VENDA.CDFILIAL = ITEMVENDA.CDFILIAL
                    AND VENDA.MODALIDADE = ITEMVENDA.MODALIDADE
                    AND VENDA.NRORG = ITEMVENDA.NRORG
            GROUP BY VENDA.CDFILIAL, VENDA.NMFILIAL, VENDA.MODALIDADE, VENDA.NROPESSOAS
        ) TAB1
        LEFT JOIN (
            SELECT V.CDFILIAL, '', 'TODOS' AS MODALIDADE, NVL(SUM(NVL(I.VRACRITVEND,0)), 0)AS VALOR_TOTAL, 0
                FROM VENDA V
                    JOIN ITEMVENDA I
                        ON V.NRSEQVENDA = I.NRSEQVENDA
                            AND V.CDCAIXA  = I.CDCAIXA        
                            AND V.CDFILIAL = I.CDFILIAL
                            AND V.NRORG    = I.NRORG
                    JOIN LOJA L
                        ON I.CDPRODUTO = L.CDPRODTAXAENTR
                            AND L.CDLOJA   = V.CDLOJA
                            AND L.CDFILIAL = V.CDFILIAL       
                            AND L.NRORG    = V.NRORG
                            AND I.NRORG    = L.NRORG
                    LEFT JOIN ORIGEMVENDAFOS O
                        ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                            AND V.NRORG = O.NRORG
                WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0 
                    AND L.IDTRATTAXAENTR = 'P'           
                    AND V.IDSITUVENDA = 'O'
                    AND I.NRORG = :NRORG
                    AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                    AND ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                    AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                GROUP BY V.CDFILIAL
        ) TAB2
            ON TAB1.CDFILIAL = TAB2.CDFILIAL
                AND TAB1.MODALIDADE = TAB2.MODALIDADE
        ORDER BY TAB1.CDFILIAL
    ";
    
    const GET_FATURAMENTODELIVERY_DIA_ANALITICO = "
       SELECT TO_CHAR(TAB1.DTENTRVENDA, 'DD/MM/YYYY') AS DATA,
            TAB1.CDFILIAL || ' - ' || TAB1.NMFILIAL AS CODFILIAL,
            TAB1.CDFILIAL AS CODIGOFILIAL, TAB1.MODALIDADE AS MODALIDADE, 
            NVL(TAB1.VALOR_TOTAL, 0) - NVL(TAB2.VALOR_TOTAL, 0) AS VRVENDA,
            NVL(TAB2.VALOR_TOTAL, 0) AS VRTXENTREGA,
            NVL(TAB1.VALOR_TOTAL, 0) AS VRTOTAL,
            TAB1.NROPESSOAS,
            TRUNC((NVL(TAB1.VALOR_TOTAL, 0))/TAB1.NROPESSOAS, 2) AS TICKETMEDIO
        FROM (
            SELECT VENDA.DTENTRVENDA, VENDA.CDFILIAL, VENDA.NMFILIAL,
                    VENDA.MODALIDADE, SUM(ITEMVENDA.VALOR_TOTAL) AS VALOR_TOTAL,
                    VENDA.NROPESSOAS AS NROPESSOAS
            FROM (
                SELECT DTENTRVENDA, CDFILIAL, NMFILIAL, NRORG, MODALIDADE, 
                        SUM(NROPESSOAS) AS NROPESSOAS 
                    FROM (
                        SELECT V.DTENTRVENDA, V.CDFILIAL, F.NMFILIAL, V.NRSEQVENDA,
                                NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                SUM(NVL(V.NRPESMESAVENDA, 1)) AS NROPESSOAS, V.NRORG, V.CDCAIXA
                            FROM VENDA V
                                JOIN FILIAL F
                                    ON V.CDFILIAL = F.CDFILIAL
                                        AND V.NRORG = F.NRORG
                                LEFT JOIN ORIGEMVENDAFOS O
                                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                        AND V.NRORG = O.NRORG
                            WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                                AND ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                AND V.IDSITUVENDA = 'O'
                                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                AND V.NRORG = :NRORG
                            GROUP BY V.DTENTRVENDA, V.CDFILIAL, F.NMFILIAL,
                                    V.NRSEQVENDA, O.DSORIGEMVENDA, V.NRORG, V.CDCAIXA
                    ) 
                    GROUP BY DTENTRVENDA, CDFILIAL, NMFILIAL, MODALIDADE, NRORG
            ) VENDA
            JOIN (
            SELECT DTENTRVENDA, CDFILIAL, MODALIDADE, CDCAIXA, NRORG, SUM(VALOR_TOTAL) AS VALOR_TOTAL 
                FROM (
                        SELECT V.DTENTRVENDA, ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, 
                                NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE, ITV.NRORG,
                                SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) - NVL(ITV.VRDESITVEND, 0) + NVL(ITV.VRACRITVEND, 0)) AS VALOR_TOTAL
                            FROM VENDA V
                                JOIN ITEMVENDA ITV
                                    ON V.CDFILIAL = ITV.CDFILIAL
                                        AND V.CDCAIXA    = ITV.CDCAIXA
                                        AND V.NRSEQVENDA = ITV.NRSEQVENDA
                                        AND V.NRORG      = ITV.NRORG
                                LEFT JOIN ORIGEMVENDAFOS O
                                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                        AND V.NRORG    = O.NRORG
                            WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                                AND ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))
                                AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                AND V.IDSITUVENDA = 'O'
                                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T')) 
                                AND V.NRORG = :NRORG
                            GROUP BY V.DTENTRVENDA, ITV.CDFILIAL, ITV.CDCAIXA, O.DSORIGEMVENDA, ITV.NRSEQVENDA, ITV.NRORG
                ) 
                GROUP BY DTENTRVENDA, CDFILIAL, MODALIDADE, CDCAIXA, NRORG
            ) ITEMVENDA
                ON VENDA.CDFILIAL = ITEMVENDA.CDFILIAL
                    AND VENDA.MODALIDADE = ITEMVENDA.MODALIDADE
                    AND VENDA.NRORG = ITEMVENDA.NRORG
                    AND VENDA.DTENTRVENDA = ITEMVENDA.DTENTRVENDA
            GROUP BY VENDA.DTENTRVENDA, VENDA.CDFILIAL, VENDA.NMFILIAL, VENDA.MODALIDADE, VENDA.NROPESSOAS
        ) TAB1
            LEFT JOIN (
            SELECT V.DTENTRVENDA, V.CDFILIAL, '', 
                    NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                    NVL(SUM(NVL(I.VRACRITVEND, 0)), 0) AS VALOR_TOTAL, 0
                FROM VENDA V
                    JOIN ITEMVENDA I
                        ON V.NRSEQVENDA = I.NRSEQVENDA
                            AND V.CDCAIXA  = I.CDCAIXA
                            AND V.CDFILIAL = I.CDFILIAL
                            AND V.NRORG    = I.NRORG
                    JOIN LOJA L
                        ON I.CDPRODUTO = L.CDPRODTAXAENTR
                            AND I.NRORG    = L.NRORG
                            AND L.CDLOJA   = V.CDLOJA
                            AND L.CDFILIAL = V.CDFILIAL
                            AND L.NRORG    = V.NRORG
                    LEFT JOIN ORIGEMVENDAFOS O
                        ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                            AND V.NRORG    = O.NRORG
                WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                    AND L.IDTRATTAXAENTR = 'P'
                    AND ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                    AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                    AND V.IDSITUVENDA = 'O'
                    AND I.NRORG = :NRORG
                    AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                GROUP BY V.DTENTRVENDA, V.CDFILIAL, O.DSORIGEMVENDA
        ) TAB2
            ON TAB1.CDFILIAL = TAB2.CDFILIAL
                AND TAB1.MODALIDADE  = TAB2.MODALIDADE
                AND TAB1.DTENTRVENDA = TAB2.DTENTRVENDA
        ORDER BY TAB1.CDFILIAL, TAB1.DTENTRVENDA
    ";
  
    const GET_FATURAMENTODELIVERY_DIA_SINTETICO = "
       SELECT TO_CHAR(TAB1.DTENTRVENDA, 'DD/MM/YYYY') AS DATA,
            TAB1.CDFILIAL || ' - ' || TAB1.NMFILIAL AS CODFILIAL,
            TAB1.CDFILIAL AS CODIGOFILIAL,
            TAB1.MODALIDADE AS MODALIDADE, 
            NVL(TAB1.VALOR_TOTAL, 0) - NVL(TAB2.VALOR_TOTAL, 0) AS VRVENDA,
            NVL(TAB2.VALOR_TOTAL, 0) AS VRTXENTREGA,
            NVL(TAB1.VALOR_TOTAL, 0) AS VRTOTAL,
            TAB1.NROPESSOAS,
            TRUNC((NVL(TAB1.VALOR_TOTAL, 0)) / TAB1.NROPESSOAS, 2) AS TICKETMEDIO
        FROM (
            SELECT VENDA.DTENTRVENDA, VENDA.CDFILIAL, VENDA.NMFILIAL,
                    VENDA.MODALIDADE, SUM(ITEMVENDA.VALOR_TOTAL) AS VALOR_TOTAL,
                    VENDA.NROPESSOAS AS NROPESSOAS
            FROM (
                SELECT DTENTRVENDA, CDFILIAL, NMFILIAL, NRORG, MODALIDADE, SUM(NROPESSOAS) AS NROPESSOAS 
                    FROM (
                        SELECT V.DTENTRVENDA, V.CDFILIAL, F.NMFILIAL,
                                V.NRSEQVENDA, 'TODOS' AS MODALIDADE,
                                SUM(NVL(V.NRPESMESAVENDA, 1)) AS NROPESSOAS,
                                V.NRORG, V.CDCAIXA
                            FROM VENDA V
                                JOIN FILIAL F
                                    ON V.CDFILIAL = F.CDFILIAL
                                        AND V.NRORG = F.NRORG
                                LEFT JOIN ORIGEMVENDAFOS O
                                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                        AND V.NRORG = O.NRORG
                            WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                                AND ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) OR (:TCDLOJA  = 'T'))
                                AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                AND V.IDSITUVENDA = 'O'
                                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                AND V.NRORG = :NRORG
                            GROUP BY V.DTENTRVENDA, V.CDFILIAL, F.NMFILIAL, 
                                    V.NRSEQVENDA, V.NRORG, V.CDCAIXA
                    ) 
                    GROUP BY DTENTRVENDA, CDFILIAL, NMFILIAL, MODALIDADE, NRORG
            ) VENDA
            JOIN (
                SELECT DTENTRVENDA, CDFILIAL, MODALIDADE, CDCAIXA, NRORG, SUM(VALOR_TOTAL) AS VALOR_TOTAL 
                    FROM (
                        SELECT V.DTENTRVENDA, ITV.CDFILIAL, ITV.CDCAIXA,
                                ITV.NRSEQVENDA, 'TODOS' AS MODALIDADE, ITV.NRORG,
                                SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) - NVL(ITV.VRDESITVEND, 0) + NVL(ITV.VRACRITVEND, 0)) AS VALOR_TOTAL
                            FROM VENDA V
                                JOIN ITEMVENDA ITV
                                    ON V.CDFILIAL = ITV.CDFILIAL
                                        AND V.CDCAIXA    = ITV.CDCAIXA
                                        AND V.NRSEQVENDA = ITV.NRSEQVENDA
                                        AND V.NRORG      = ITV.NRORG
                                LEFT JOIN ORIGEMVENDAFOS O
                                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                        AND V.NRORG = O.NRORG
                            WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                                AND ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                                AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                                AND V.IDSITUVENDA = 'O'
                                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                AND V.NRORG = :NRORG
                            GROUP BY V.DTENTRVENDA, ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, ITV.NRORG
                    ) 
                    GROUP BY DTENTRVENDA, CDFILIAL, MODALIDADE, CDCAIXA, NRORG
            ) ITEMVENDA
                ON VENDA.CDFILIAL = ITEMVENDA.CDFILIAL
                    AND VENDA.MODALIDADE = ITEMVENDA.MODALIDADE
                    AND VENDA.NRORG = ITEMVENDA.NRORG
                    AND VENDA.DTENTRVENDA = ITEMVENDA.DTENTRVENDA
            GROUP BY VENDA.DTENTRVENDA, VENDA.CDFILIAL, VENDA.NMFILIAL, VENDA.MODALIDADE, VENDA.NROPESSOAS
        ) TAB1
        LEFT JOIN (
        SELECT V.DTENTRVENDA, V.CDFILIAL, '', 
                'TODOS' AS MODALIDADE,
                NVL(SUM(NVL(I.VRACRITVEND, 0)), 0) AS VALOR_TOTAL, 0
            FROM VENDA V
                JOIN ITEMVENDA I
                    ON V.NRSEQVENDA = I.NRSEQVENDA
                        AND V.CDCAIXA  = I.CDCAIXA
                        AND V.CDFILIAL = I.CDFILIAL
                        AND V.NRORG    = I.NRORG
                JOIN LOJA L
                    ON I.CDPRODUTO     = L.CDPRODTAXAENTR
                        AND I.NRORG    = L.NRORG
                        AND L.CDLOJA   = V.CDLOJA
                        AND L.CDFILIAL = V.CDFILIAL
                        AND L.NRORG    = V.NRORG
                LEFT JOIN ORIGEMVENDAFOS O
                    ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                        AND V.NRORG = O.NRORG
            WHERE INSTR(:CDFILIAL, V.CDFILIAL) > 0
                AND L.IDTRATTAXAENTR = 'P'
                AND ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                AND V.IDSITUVENDA = 'O'
                AND I.NRORG = :NRORG
                AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T')) 
            GROUP BY V.DTENTRVENDA, V.CDFILIAL
        ) TAB2
        ON TAB1.CDFILIAL = TAB2.CDFILIAL
            AND TAB1.MODALIDADE  = TAB2.MODALIDADE
            AND TAB1.DTENTRVENDA = TAB2.DTENTRVENDA
        ORDER BY TAB1.CDFILIAL, TAB1.DTENTRVENDA
    ";   
  
    const GET_FATURAMENTO_TOTAL_POR_MODALIDADE = "
       SELECT 'TODOS' AS NMFILIAL, TAB1.CDFILIAL, TAB1.CDFILIAL || ' - ' || TAB1.NMFILIAL AS CODFILIAL, 
            TAB1.MODALIDADE AS NMMODALIDADE,  NVL(TAB1.VALOR_VENDIDO, 0) + NVL(TAB3.VALOR_TOTAL, 0) AS VALOR_VENDIDO, 
            NVL(TAB1.VRDESCONTO, 0) AS VRDESCONTO 
        FROM (
            SELECT VENDA.CDFILIAL, VENDA.NMFILIAL, 
                    VENDA.MODALIDADE, SUM(ITEMVENDA.VALOR_VENDIDO) AS VALOR_VENDIDO, 
                    SUM(ITEMVENDA.VRDESCONTO) AS VRDESCONTO, 
                    SUM(ITEMVENDA.VRACRESCIMO) AS VRACRESCIMO, 
                    SUM(ITEMVENDA.VRCANCELAMENTO) AS VRCANCELAMENTO, 
                    SUM(ITEMVENDA.VALOR_TOTAL) AS VALOR_TOTAL, 
                    SUM(ITEMVENDA.QTD_TOTAL) AS QTD_TOTAL, 
                    SUM(VENDA.VRREPIQUE) AS VRREPIQUE, 
                    SUM(VENDA.NROPESSOAS) AS NROPESSOAS 
            FROM (
                SELECT CDFILIAL, NMFILIAL, 
                        NRORG, MODALIDADE, 
                        SUM(VRREPIQUE) AS VRREPIQUE, 
                        SUM(NROPESSOAS) AS NROPESSOAS 
                FROM (
                    WITH FLC AS (
                        SELECT DISTINCT V.CDFILIAL, V.CDLOJA, 
                                        V.CDCAIXA, L.IDCOMISVENDA, V.NMFILIAL 
                        FROM V_FILIALLOJACAIXA V, LOJA L 
                        WHERE ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) 
                                    OR (:TCDLOJA = 'T')
                                ) 
                            AND INSTR(:CDFILIAL, V.CDFILIAL) > 0 
                            AND V.CDFILIAL = L.CDFILIAL 
                            AND V.CDLOJA = L.CDLOJA
                    ) 
                    SELECT V.CDFILIAL, FLC.NMFILIAL, V.NRSEQVENDA, 
                            NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE, 
                            SUM(NVL(V.NRPESMESAVENDA, 1)) AS NROPESSOAS, 
                            SUM(NVL(V.VRREPIQUEVENDA, 0)) AS VRREPIQUE, 
                            V.NRORG, V.CDCAIXA 
                    FROM VENDA V
                        JOIN FLC
                            ON V.CDFILIAL = FLC.CDFILIAL 
                                AND V.CDCAIXA = FLC.CDCAIXA 
                                AND V.CDLOJA  = FLC.CDLOJA
                        LEFT JOIN ORIGEMVENDAFOS O
                            ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                AND V.NRORG = O.NRORG
                    WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN 
                        AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T')) 
                        AND V.NRORG = :NRORG 
                        AND V.IDSITUVENDA IN(
                            CASE 
                                WHEN V.IDORIGEMVENDA LIKE 'AJU%' 
                                    THEN V.IDSITUVENDA
                                ELSE 'O'
                            END
                        ) 
                        AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                    GROUP BY V.CDFILIAL, FLC.NMFILIAL, V.NRSEQVENDA, 
                                O.DSORIGEMVENDA, V.NRORG, V.CDCAIXA
                    ) 
                GROUP BY CDFILIAL, NMFILIAL, MODALIDADE, NRORG
                ) VENDA 
                    JOIN (
                        SELECT VENDAS_OK.CDFILIAL, VENDAS_OK.MODALIDADE, VENDAS_OK.NRORG, 
                                NVL(SUM(VENDAS_OK.VALOR_VENDIDO), 0) AS VALOR_VENDIDO, 
                                NVL(SUM(VENDAS_OK.VRDESCONTO), 0) AS VRDESCONTO, 
                                NVL(SUM(VENDAS_OK.VRACRESCIMO), 0) AS VRACRESCIMO, 
                                NVL(SUM(VENDAS_CANCELAMENTO.VRCANCELAMENTO), 0) AS VRCANCELAMENTO, 
                                NVL(SUM(VENDAS_OK.VALOR_TOTAL), 0) AS VALOR_TOTAL, 
                                SUM(QTD_TOTAL) AS QTD_TOTAL 
                        FROM (
                            SELECT CDFILIAL, MODALIDADE, CDCAIXA, NRORG, 
                                    SUM(VRDESCONTO) AS VRDESCONTO, 
                                    SUM(VRACRESCIMO) AS VRACRESCIMO, 
                                    SUM(VALOR_VENDIDO) AS VALOR_VENDIDO, 
                                    SUM(VALOR_TOTAL) AS VALOR_TOTAL, 
                                    SUM(QTD_TOTAL) AS QTD_TOTAL 
                            FROM (
                                WITH FLC AS (
                                    SELECT DISTINCT V.CDFILIAL, V.CDLOJA, V.CDCAIXA, 
                                                    L.IDCOMISVENDA, V.NMFILIAL 
                                        FROM V_FILIALLOJACAIXA V, LOJA L 
                                        WHERE ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) 
                                                    OR (:TCDLOJA = 'T')) 
                                            AND INSTR(:CDFILIAL, V.CDFILIAL) > 0 
                                            AND V.CDFILIAL = L.CDFILIAL 
                                            AND V.CDLOJA = L.CDLOJA
                                ) 
                                SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, 
                                        NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE, 
                                        ITV.NRORG, SUM(TRUNC(NVL(ITV.VRDESITVEND, 0), 2)) AS VRDESCONTO, 
                                        CASE V.IDSITUVENDA 
                                            WHEN 'C' THEN 0 
                                            ELSE SUM(TRUNC(NVL(ITV.VRACRITVEND, 0), 2)) 
                                        END AS VRACRESCIMO, 
                                        CASE V.IDSITUVENDA 
                                            WHEN 'C' THEN 0 
                                            ELSE SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) - NVL(ITV.VRDESITVEND, 0)) 
                                        END AS VALOR_VENDIDO, 
                                        SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) - NVL(ITV.VRDESITVEND, 0) + NVL(ITV.VRACRITVEND, 0)) AS VALOR_TOTAL, 
                                        SUM(ITV.QTPRODVEND) AS QTD_TOTAL 
                                    FROM VENDA V
                                        JOIN FLC
                                            ON V.CDFILIAL = FLC.CDFILIAL 
                                                AND V.CDCAIXA = FLC.CDCAIXA 
                                                AND V.CDLOJA = FLC.CDLOJA
                                        JOIN ITEMVENDA ITV
                                            ON V.CDFILIAL = ITV.CDFILIAL 
                                                AND V.CDCAIXA = ITV.CDCAIXA 
                                                AND V.NRSEQVENDA = ITV.NRSEQVENDA 
                                                AND V.NRORG = ITV.NRORG 
                                        LEFT JOIN ORIGEMVENDAFOS O
                                            ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                                AND V.NRORG = O.NRORG
                                    WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN 
                                        AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                        AND V.NRORG = :NRORG 
                                        AND V.IDSITUVENDA IN(
                                            CASE 
                                                WHEN V.IDORIGEMVENDA LIKE 'AJU%' 
                                                    THEN V.IDSITUVENDA
                                                ELSE 'O'
                                            END
                                        ) 
                                        AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                                    GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, O.DSORIGEMVENDA, 
                                                ITV.NRSEQVENDA, ITV.NRORG, V.IDSITUVENDA
                            ) 
                            GROUP BY CDFILIAL, MODALIDADE, CDCAIXA, NRORG
                        ) VENDAS_OK 
                        LEFT JOIN (
                            SELECT CDFILIAL, CDCAIXA, MODALIDADE, NRORG, 
                                    SUM(VRCANCELAMENTO) AS VRCANCELAMENTO 
                                FROM (
                                    WITH FLC AS (
                                        SELECT DISTINCT V.CDFILIAL, V.CDLOJA, 
                                                        V.CDCAIXA, L.IDCOMISVENDA, V.NMFILIAL 
                                            FROM V_FILIALLOJACAIXA V, LOJA L 
                                            WHERE ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) 
                                                    OR (:TCDLOJA = 'T')) 
                                                AND INSTR(:CDFILIAL, V.CDFILIAL) > 0 
                                                AND V.CDFILIAL = L.CDFILIAL 
                                                AND V.CDLOJA = L.CDLOJA
                                    ) 
                                    SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, ITV.NRORG, 
                                            NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE, 
                                            SUM(TRUNC(ITV.QTPRODVEND * (ITV.VRUNITVEND + NVL(ITV.VRUNITVENDCL, 0)), 2) + NVL(ITV.VRACRITVEND, 0) - NVL(ITV.VRDESITVEND, 0)) AS VRCANCELAMENTO, 
                                            SUM(ITV.QTPRODVEND) AS QTD_TOTAL
                                        FROM VENDA V
                                            JOIN FLC
                                                ON V.CDFILIAL = FLC.CDFILIAL 
                                                    AND V.CDCAIXA = FLC.CDCAIXA 
                                                    AND V.CDLOJA  = FLC.CDLOJA 
                                            JOIN ITEMVENDA ITV
                                                ON V.CDFILIAL = ITV.CDFILIAL 
                                                    AND V.CDCAIXA    = ITV.CDCAIXA 
                                                    AND V.NRSEQVENDA = ITV.NRSEQVENDA 
                                                    AND V.NRORG      = ITV.NRORG 
                                            LEFT JOIN ORIGEMVENDAFOS O
                                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                                    AND V.NRORG    = O.NRORG
                                        WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN 
                                            AND V.IDSITUVENDA = 'C' 
                                            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                            AND V.NRORG = :NRORG 
                                            AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                                    GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, ITV.NRORG, O.DSORIGEMVENDA 
                                    
                                    UNION 
            
                                    SELECT ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, ITV.NRORG, 
                                            NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                                            SUM(TRUNC(ITV.QTPRODVENDC * (ITV.VRUNITVENDC + NVL(ITV.VRUNITVENCLC, 0)), 2) + NVL(ITV.VRACRITVENDC, 0) - NVL(ITV.VRDESITVENDC, 0)) AS VRCANCELAMENTO, 
                                            SUM(ITV.QTPRODVENDC) AS QTD_TOTAL 
                                        FROM VENDA V
                                            JOIN (
                                                    SELECT DISTINCT V.CDFILIAL, V.CDLOJA, 
                                                                    V.CDCAIXA, L.IDCOMISVENDA 
                                                        FROM V_FILIALLOJACAIXA V, LOJA L 
                                                        WHERE ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) 
                                                                OR (:TCDLOJA = 'T')
                                                            ) 
                                                            AND INSTR(:CDFILIAL, V.CDFILIAL) > 0 
                                                            AND V.CDFILIAL = L.CDLOJA 
                                                            AND V.CDLOJA = L.CDLOJA
                                            ) FLC
                                                ON V.CDFILIAL = FLC.CDFILIAL 
                                                    AND V.CDCAIXA = FLC.CDCAIXA 
                                                    AND V.CDLOJA  = FLC.CDLOJA 
                                            JOIN ITVENDACAN ITV 
                                                ON V.CDFILIAL = ITV.CDFILIAL 
                                                    AND V.CDCAIXA    = ITV.CDCAIXA 
                                                    AND V.NRSEQVENDA = ITV.NRSEQVENDA 
                                                    AND V.NRORG      = ITV.NRORG 
                                            LEFT JOIN ORIGEMVENDAFOS O
                                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                                    AND V.NRORG = O.NRORG
                                        WHERE V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN 
                                            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                                            AND V.NRORG = :NRORG 
                                            AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                                    GROUP BY ITV.CDFILIAL, ITV.CDCAIXA, ITV.NRSEQVENDA, 
                                            ITV.NRORG, O.DSORIGEMVENDA
                                ) 
                            GROUP BY CDFILIAL, CDCAIXA, MODALIDADE, NRORG
                        ) VENDAS_CANCELAMENTO 
                                    ON VENDAS_OK.CDFILIAL = VENDAS_CANCELAMENTO.CDFILIAL 
                                        AND VENDAS_OK.CDCAIXA = VENDAS_CANCELAMENTO.CDCAIXA 
                                        AND VENDAS_OK.MODALIDADE = VENDAS_CANCELAMENTO.MODALIDADE 
                                        AND VENDAS_OK.NRORG = VENDAS_CANCELAMENTO.NRORG 
                        GROUP BY VENDAS_OK.CDFILIAL, VENDAS_OK.MODALIDADE, VENDAS_OK.NRORG
                    ) ITEMVENDA 
                        ON VENDA.CDFILIAL = ITEMVENDA.CDFILIAL 
                            AND VENDA.MODALIDADE = ITEMVENDA.MODALIDADE 
                            AND VENDA.NRORG = ITEMVENDA.NRORG 
                    GROUP BY VENDA.CDFILIAL, VENDA.NMFILIAL, VENDA.MODALIDADE
        ) TAB1 
        LEFT JOIN (
            SELECT TB2.CDFILIAL, '', TB2.MODALIDADE, SUM(TB2.VALOR_TOTAL) AS VALOR_TOTAL, 0 
                FROM (
                    SELECT V.CDFILIAL, '', NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                            SUM(I.QTPRODVEND) AS QTD_TOTAL, 
                            NVL(SUM(NVL(I.VRACRITVEND, 0)), 0) AS VALOR_TOTAL, 0 
                        FROM ITEMVENDA I
                            JOIN (
                                SELECT DISTINCT V.CDFILIAL, V.CDLOJA, V.CDCAIXA, 
                                                L.IDCOMISVENDA, L.CDPRODTAXASERV, L.IDTRATTAXASERV 
                                    FROM V_FILIALLOJACAIXA V, LOJA L 
                                    WHERE ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) 
                                                OR (:TCDLOJA = 'T')
                                            ) 
                                        AND INSTR(:CDFILIAL, V.CDFILIAL) > 0 
                                        AND V.CDFILIAL = L.CDFILIAL 
                                        AND V.CDLOJA   = L.CDLOJA
                            ) FLC
                                ON I.CDPRODUTO = FLC.CDPRODTAXASERV
                            JOIN VENDA V 
                                ON V.NRSEQVENDA = I.NRSEQVENDA 
                                    AND V.CDCAIXA  = I.CDCAIXA 
                                    AND V.CDFILIAL = I.CDFILIAL 
                                    AND V.CDFILIAL = FLC.CDFILIAL 
                                    AND V.CDCAIXA  = FLC.CDCAIXA 
                                    AND V.CDLOJA   = FLC.CDLOJA
                            LEFT JOIN ORIGEMVENDAFOS O
                                ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                                    AND V.NRORG = O.NRORG
                        WHERE FLC.IDCOMISVENDA IN ('S', 'G') 
                            AND FLC.IDTRATTAXASERV = 'P' 
                            AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN 
                            AND V.IDSITUVENDA = 'O' 
                            AND SUBSTR(V.IDORIGEMVENDA, 0, 3) <> 'DLV' 
                            AND I.NRORG = :NRORG 
                            AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                            AND V.IDTPAMBNFCE = :IDTPAMBNFCE
                    GROUP BY V.CDFILIAL, O.DSORIGEMVENDA
                ) TB2 
            GROUP BY TB2.CDFILIAL, TB2.MODALIDADE
        ) TAB2 
            ON TAB1.CDFILIAL = TAB2.CDFILIAL 
                AND TAB1.MODALIDADE = TAB2.MODALIDADE 
        LEFT JOIN (
            SELECT V.CDFILIAL, '', NVL(O.DSORIGEMVENDA, 'Modalidade Desconhecida') AS MODALIDADE,
                    SUM(I.QTPRODVEND) AS QTD_TOTAL, 
                    NVL(SUM(NVL(I.VRACRITVEND, 0)) - SUM(NVL(V.VRREPIQUEVENDA, 0)), 0) AS VALOR_TOTAL, 0 
                FROM ITEMVENDA I
                    JOIN (
                        SELECT DISTINCT V.CDFILIAL, V.CDLOJA, V.CDCAIXA, 
                                        L.IDCOMISVENDA, L.CDPRODTAXASERV, 
                                        L.IDTRATTAXASERV, L.IDTRATTAXAENTR 
                            FROM V_FILIALLOJACAIXA V, LOJA L 
                            WHERE ((INSTR(:CDLOJA, V.CDFILIAL || V.CDLOJA) > 0) 
                                        OR (:TCDLOJA = 'T')
                                    ) 
                                AND INSTR(:CDFILIAL, V.CDFILIAL) > 0 
                                AND V.CDFILIAL = L.CDFILIAL 
                                AND V.CDLOJA = L.CDLOJA
                    ) FLC
                        ON I.CDPRODUTO = FLC.CDPRODTAXASERV
                    JOIN VENDA V 
                        ON V.NRSEQVENDA = I.NRSEQVENDA 
                            AND V.CDCAIXA  = I.CDCAIXA 
                            AND V.CDFILIAL = I.CDFILIAL 
                            AND V.CDFILIAL = FLC.CDFILIAL 
                            AND V.CDCAIXA  = FLC.CDCAIXA 
                            AND V.CDLOJA   = FLC.CDLOJA
                    LEFT JOIN ORIGEMVENDAFOS O
                        ON V.IDORIGEMVENDA = O.IDORIGEMVENDA
                            AND V.NRORG = O.NRORG
                WHERE FLC.IDTRATTAXAENTR = 'P' 
                    AND SUBSTR(V.IDORIGEMVENDA, 0, 3) = 'DLV' 
                    AND V.IDSITUVENDA = 'O' 
                    AND ((INSTR(:MODALIDADE, O.IDORIGEMVENDA) <> 0) OR (:TMODALIDADE = 'T'))
                    AND V.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN
                    AND V.IDTPAMBNFCE = :IDTPAMBNFCE
            GROUP BY V.CDFILIAL, O.DSORIGEMVENDA
        ) TAB3
            ON TAB1.CDFILIAL = TAB3.CDFILIAL 
                AND TAB1.MODALIDADE = TAB3.MODALIDADE 
        ORDER BY TAB1.CDFILIAL
    ";
     
    const GET_VFILIALLOJACAIXA = "SELECT DISTINCT V.CDFILIAL,
                               V.CDLOJA,
                               V.CDCAIXA,
                               L.IDCOMISVENDA,
                               V.NMFILIAL,
                               L.CDPRODTAXAENTR, 
                               L.IDTRATTAXAENTR, 
                               L.CDPRODTAXASERV, 
                               L.IDTRATTAXASERV
               FROM V_FILIALLOJACAIXA V,
                    LOJA L
               WHERE ((INSTR(:CDLOJA, V.CDFILIAL||V.CDLOJA) > 0) OR (:TCDLOJA = 'T'))
                 AND INSTR(:CDFILIAL, V.CDFILIAL) > 0
                 AND V.CDFILIAL = L.CDFILIAL
                 AND V.CDLOJA = L.CDLOJA";
        
    const GET_ARRAY_MODALIDADE =
       "SELECT IDORIGEMVENDA
        FROM ORIGEMVENDAFOS O
        WHERE NRORG = :NRORG
            AND IDATIVO = 'S'
            AND ((INSTR(:MODALIDADE, SUBSTR(O.IDORIGEMVENDA, :P11, :P12)) <> 0) OR :TMODALIDADE = 'T')
            AND ((INSTR(:FLAG, SUBSTR(O.IDORIGEMVENDA, :P21, :P22)) = 0) OR :TFLAG = 'T')";
}