<?php
namespace Teknisa\MAN\Services;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Factories;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;

class TransfMovimentacaoService extends StoredProcedure {

    protected $entityManager;
	protected $util;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager, Utilities\Util $util, Connection $connection)  {
		parent::__construct($connection, 'ATUALIZA_SALDO_CONS');
		$this->entityManager = $entityManager;
		$this->util = $util;
	}
	
	public function adqMoviClie($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqMoviClie, $params);
		return $query;
	}
	
	public function adqCentroCusto($params){
		$query = $this->entityManager->getConnection()->fetchAll(self::adqCentroCusto, $params);
		return $query;
	}
	
	public function adqInsMov($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::adqInsMov, $params);
		return $query;
	}
	
	public function adqTranMovi($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::adqTranMovi, $params);
		return $query;
	}
	
	public function adqTranVend($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::adqTranVend, $params);
		return $query;
	}
	
	public function adqInsereLog($params){
		$query = $this->entityManager->getConnection()->executeQuery(self::adqInsereLog, $params);
		return $query;
	}
	
	public function geraNovoCodigo(){
		$query = $this->entityManager->getConnection()->fetchAll(self::geraNovoCodigo);
		return $query;
	}
	
	public function alterSession(){
		$query = $this->entityManager->getConnection()->executeQuery(self::alterSession);
		return $query;
	}
	
	public function getCurrentDate(){
		$query = $this->entityManager->getConnection()->fetchAll(self::getCurrentDate);
		return $query;
	}
	
	public function AtualizaSaldoCons($FILIAL, $CLIENTE, $CONSUMIDOR, $DATAPARAM, $OPERADORPARAM) {
        try {
            $CDFILIAL  = $FILIAL;
            $CDCLIENTE  = $CLIENTE;
            $CDCONSUMIDOR  = $CONSUMIDOR;
            $DATA = $DATAPARAM;
            $OPERADOR = $OPERADORPARAM;
            $this->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $CDFILIAL, Param::PARAM_TYPE_STR, strlen($CDFILIAL)));
			$this->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $CDCLIENTE, Param::PARAM_TYPE_STR, strlen($CDCLIENTE)));
            $this->addParam(new Param('P_CDCONSUMIDOR', Param::PARAM_INPUT, $CDCONSUMIDOR, Param::PARAM_TYPE_STR, strlen($CDCONSUMIDOR)));
            $this->addParam(new Param('P_DATA', Param::PARAM_INPUT, $DATA, Param::PARAM_TYPE_STR, strlen($DATA)));
            $this->addParam(new Param('P_OPERADOR', Param::PARAM_INPUT, $OPERADOR, Param::PARAM_TYPE_STR, strlen($OPERADOR)));
            $this->execute();
            $this->params = array();
            return 'OK';
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    const alterSession = "ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";
	
	const adqMoviClie = "SELECT
						   CDCLIENTE   , NRSEQMOVCLI , CDCONSUMIDOR, VRMOVCLI    ,
						   DTMOVCLI    , DSHISTMOV   , IDTIPMOCVLI , CDFILIAL    , 
						   CDCAIXA     , NRSEQVENDA  , DTABERCAIX  , NRSEQUMOVI  ,  
						   CDTIPORECE  , VRSALDOCONS , VRMOVPESCONS, VRSALDPECONS,   
						   CDOPERADOR  , CDOPERECSALD, DTATUMOVCLIE, DSATUMOVCLIE,   
						   DTMOVIMCLIE , DTRECMOVCLIE, CDFILIAPFATU, NRAPURACFATU,   
						   VRPESUBSIDIO, VRTETOSUBSID   
						FROM
						   MOVICLIE
						WHERE
						   (CDCLIENTE    = :CDCLIENTE   )				 AND
						   (IDTIPMOCVLI <> 'X'          ) 				 AND
						   (CDCONSUMIDOR = :CDCONSUMIDOR)				 AND
						   ((INSTR(:NRSEQVENDA, NRSEQVENDA) <> 0))		 AND
						   (DTMOVIMCLIE BETWEEN :DTMOVINI AND :DTMOVFIN) AND
						   (NRORG = :NRORG)
						ORDER BY
						   DTMOVCLI";
						   
	const adqCentroCusto = "SELECT CDCLIENTE, CDCONSUMIDOR, CDCCUSCLIE
							FROM CONSUMIDOR
							WHERE (CDCLIENTE = :CDCLIENTE      ) AND
							      (CDCONSUMIDOR = :CDCONSUMIDOR) AND
							      (NRORG = :NRORG)";
							      
	const adqInsMov = "INSERT INTO MOVICLIE
						(CDCLIENTE   , NRSEQMOVCLI , CDCONSUMIDOR, VRMOVCLI    ,
						   DTMOVCLI    , DSHISTMOV   , IDTIPMOCVLI , CDFILIAL    ,
						   CDCAIXA     , NRSEQVENDA  , DTABERCAIX  , NRSEQUMOVI  ,
						   CDTIPORECE  , VRSALDOCONS , VRMOVPESCONS, VRSALDPECONS,
						   CDOPERADOR  , CDOPERECSALD, DTATUMOVCLIE, DSATUMOVCLIE,
						   DTMOVIMCLIE , DTRECMOVCLIE, CDFILIAPFATU, NRAPURACFATU,
						   VRPESUBSIDIO, VRTETOSUBSID, DTULTATUMCLI)
						VALUES
						  (:CDCLIENTE   , :NRSEQMOVCLI , :CDCONSUMIDOR, :VRMOVCLI    ,
						   :DTMOVCLI    , :DSHISTMOV   , :IDTIPMOCVLI , :CDFILIAL    ,
						   :CDCAIXA     , :NRSEQVENDA  , :DTABERCAIX  , :NRSEQUMOVI  ,
						   :CDTIPORECE  , :VRSALDOCONS , :VRMOVPESCONS, :VRSALDPECONS,
						   :CDOPERADOR  , :CDOPERECSALD, :DTATUMOVCLIE, :DSATUMOVCLIE,
						   :DTMOVIMCLIE , :DTRECMOVCLIE, :CDFILIAPFATU, :NRAPURACFATU,
						   :VRPESUBSIDIO, :VRTETOSUBSID, SYSDATE)";
						   
	const adqTranMovi = "UPDATE MOVICLIE
						SET
						   IDTIPMOCVLI = 'X',
						   DSATUMOVCLIE =  :DSATUMOVCLIE
						WHERE
						   CDCLIENTE    = :OLD_CDCLIENTEDE AND
						   NRSEQMOVCLI  = :OLD_NRSEQMOVCLI AND
						   NRORG = :NRORG";
						   
	const adqTranVend = "UPDATE VENDA
						SET
						   CDCLIENTE    = :CDCLIENTE,
						   CDCONSUMIDOR = :CDCONSUMIDOR,
						   TXOBSVENDA   = :TXOBSVENDA,
						   CDCCUSCLIE   = :CDCCUSCLIE
						WHERE
						   CDFILIAL     = :OLD_CDFILIAL       AND
						   CDCLIENTE    = :OLD_CDCLIENTEDE    AND
						   CDCONSUMIDOR = :OLD_CDCONSUMIDORDE AND
						   NRSEQVENDA   = :OLD_NRSEQVENDA	  AND
						   NRORG = :NRORG";
						   
	const adqInsereLog = "INSERT INTO LOGTRMOVCONS
							(CDOPERADOR, DTTRMOVCONS, CDCLIENDE, CDCONSDE, CDFILIAL, CDCLIENPARA, CDCONSPARA, DTINTRMOVCON, NRORG)
						  VALUES
							(:CDOPERADOR, :DTTRMOVCONS, :CDCLIENDE, :CDCONSDE, :CDFILIAL, :CDCLIENPARA, :CDCONSPARA, :DTINTRMOVCON, :NRORG)";
						
	const geraNovoCodigo = "SELECT MAX(NRSEQMOVCLI)+1 AS NOVOCODIGO FROM MOVICLIE";
	
	const getCurrentDate = "SELECT TO_CHAR (SYSDATE, 'DD-MM-YYYY HH24:MI:SS') AS NOW FROM DUAL";
}